/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptionrubberband_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionRubberBand_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionRubberBand >()))
        return -1;

    ::QStyleOptionRubberBand* cptr = 0;
    int overloadId = -1;
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionRubberBand", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionRubberBand()
    // 1: QStyleOptionRubberBand(QStyleOptionRubberBand)
    // 2: QStyleOptionRubberBand(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionRubberBand()
    } else if (numArgs == 1
        && SbkNumber_Check(pyArgs[0])) {
        overloadId = 2; // QStyleOptionRubberBand(int)
    } else if (numArgs == 1
        && Shiboken::Converter< ::QStyleOptionRubberBand >::isConvertible(pyArgs[0])) {
        overloadId = 1; // QStyleOptionRubberBand(QStyleOptionRubberBand)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionRubberBand_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionRubberBand()
        {

            if(!PyErr_Occurred()) {
                // QStyleOptionRubberBand()
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionRubberBand();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 1: // QStyleOptionRubberBand(QStyleOptionRubberBand)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            const QStyleOptionRubberBand & cppArg0 = Shiboken::Converter< ::QStyleOptionRubberBand >::toCpp(pyArgs[0]);

            if(!PyErr_Occurred()) {
                // QStyleOptionRubberBand(QStyleOptionRubberBand)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionRubberBand(cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 2: // QStyleOptionRubberBand(int)
        {
            int cppArg0 = Shiboken::Converter< int >::toCpp(pyArgs[0]);

            if(!PyErr_Occurred()) {
                // QStyleOptionRubberBand(int)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionRubberBand(cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionRubberBand >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionRubberBand_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionRubberBand_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionRubberBand", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionRubberBand", overloads);
        return -1;
}

static PyMethodDef Sbk_QStyleOptionRubberBand_methods[] = {

    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionRubberBand_get_opaque(PyObject* self, void*)
{
    ::QStyleOptionRubberBand* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleOptionRubberBand* >::toCpp(self);
    PyObject* value = Shiboken::Converter< bool >::toPython(cppSelf->opaque);
    return value;
}
static int Sbk_QStyleOptionRubberBand_set_opaque(PyObject* self, PyObject* value, void*)
{
    ::QStyleOptionRubberBand* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleOptionRubberBand* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'opaque' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'opaque', 'bool' or convertible type expected");
        return -1;
    }

    cppSelf->opaque = Shiboken::Converter< bool >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionRubberBand_get_shape(PyObject* self, void*)
{
    ::QStyleOptionRubberBand* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleOptionRubberBand* >::toCpp(self);
    PyObject* value = Shiboken::Converter< ::QRubberBand::Shape >::toPython(cppSelf->shape);
    return value;
}
static int Sbk_QStyleOptionRubberBand_set_shape(PyObject* self, PyObject* value, void*)
{
    ::QStyleOptionRubberBand* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleOptionRubberBand* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'shape' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QRubberBand::Shape >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'shape', 'Shape' or convertible type expected");
        return -1;
    }

    cppSelf->shape = Shiboken::Converter< ::QRubberBand::Shape >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionRubberBand
static PyGetSetDef Sbk_QStyleOptionRubberBand_getsetlist[] = {
    {const_cast<char*>("opaque"), Sbk_QStyleOptionRubberBand_get_opaque, Sbk_QStyleOptionRubberBand_set_opaque},
    {const_cast<char*>("shape"), Sbk_QStyleOptionRubberBand_get_shape, Sbk_QStyleOptionRubberBand_set_shape},
    {0}  // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionRubberBand_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QStyleOptionRubberBand_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionRubberBand_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtGui.QStyleOptionRubberBand",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QStyleOptionRubberBand_traverse,
    /*tp_clear*/            Sbk_QStyleOptionRubberBand_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionRubberBand_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionRubberBand_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionRubberBand_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionRubberBand(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionRubberBand_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QStyleOptionRubberBand", "QStyleOptionRubberBand*",
        &Sbk_QStyleOptionRubberBand_Type, &Shiboken::callCppDestructor< ::QStyleOptionRubberBand >, (SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX])) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'StyleOptionVersion'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONVERSION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleOptionRubberBand_Type,
        "StyleOptionVersion",
        "PySide.QtGui.QStyleOptionRubberBand.StyleOptionVersion",
        "QStyleOptionRubberBand::StyleOptionVersion");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONVERSION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONVERSION_IDX],
        &Sbk_QStyleOptionRubberBand_Type, "Version", (long) QStyleOptionRubberBand::Version))
        return ;
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'StyleOptionType'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleOptionRubberBand_Type,
        "StyleOptionType",
        "PySide.QtGui.QStyleOptionRubberBand.StyleOptionType",
        "QStyleOptionRubberBand::StyleOptionType");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONRUBBERBAND_STYLEOPTIONTYPE_IDX],
        &Sbk_QStyleOptionRubberBand_Type, "Type", (long) QStyleOptionRubberBand::Type))
        return ;
    // End of 'StyleOptionType' enum.


    Shiboken::TypeResolver::createObjectTypeResolver< ::QStyleOptionRubberBand >("QStyleOptionRubberBand*");
    Shiboken::TypeResolver::createObjectTypeResolver< ::QStyleOptionRubberBand >(typeid(::QStyleOptionRubberBand).name());
    qRegisterMetaType< ::QStyleOptionRubberBand::StyleOptionVersion >("QStyleOptionRubberBand::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionRubberBand::StyleOptionType >("QStyleOptionRubberBand::StyleOptionType");
}
