/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtcore_python.h"

#include "qt_wrapper.h"

// Extra includes
#include <QTextDocument>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_Qt_methods[] = {

    {0} // Sentinel
};

} // extern "C"

static int Sbk_Qt_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_Qt_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_Qt_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtCore.Qt",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_Qt_traverse,
    /*tp_clear*/            Sbk_Qt_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_Qt_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtCore_Qt_DropAction___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DropActions >::toPython(
        Shiboken::Converter< ::Qt::DropActions>::toCpp(self)
        & Shiboken::Converter< ::Qt::DropActions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DropActions >::toPython(
        Shiboken::Converter< ::Qt::DropActions>::toCpp(self)
        | Shiboken::Converter< ::Qt::DropActions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DropActions >::toPython(
        Shiboken::Converter< ::Qt::DropActions>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::DropActions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::DropActions >::toPython(
        ~Shiboken::Converter< ::Qt::DropActions >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_DropAction_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::DropActions>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_DropAction__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::DropActions>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_DropAction_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_DropAction__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_DropAction___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_DropAction___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_DropAction___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_DropAction___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_DropAction_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_DropAction_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_DropActions_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "DropActions",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_DropAction_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_WindowType___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowFlags >::toPython(
        Shiboken::Converter< ::Qt::WindowFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::WindowFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowFlags >::toPython(
        Shiboken::Converter< ::Qt::WindowFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::WindowFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowFlags >::toPython(
        Shiboken::Converter< ::Qt::WindowFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::WindowFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::WindowFlags >::toPython(
        ~Shiboken::Converter< ::Qt::WindowFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_WindowType_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::WindowFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_WindowType__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::WindowFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_WindowType_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_WindowType__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_WindowType___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowType___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowType___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_WindowType___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_WindowType_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_WindowType_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_WindowFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "WindowFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_WindowType_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_GestureFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::GestureFlags >::toPython(
        Shiboken::Converter< ::Qt::GestureFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::GestureFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::GestureFlags >::toPython(
        Shiboken::Converter< ::Qt::GestureFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::GestureFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::GestureFlags >::toPython(
        Shiboken::Converter< ::Qt::GestureFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::GestureFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::GestureFlags >::toPython(
        ~Shiboken::Converter< ::Qt::GestureFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_GestureFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::GestureFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_GestureFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::GestureFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_GestureFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_GestureFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_GestureFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_GestureFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_GestureFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_GestureFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "GestureFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_GestureFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter< ::Qt::ImageConversionFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::ImageConversionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter< ::Qt::ImageConversionFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::ImageConversionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter< ::Qt::ImageConversionFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::ImageConversionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::ImageConversionFlags >::toPython(
        ~Shiboken::Converter< ::Qt::ImageConversionFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ImageConversionFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_ImageConversionFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ImageConversionFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_ImageConversionFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_ImageConversionFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_ImageConversionFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_ImageConversionFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ImageConversionFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "ImageConversionFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ImageConversionFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ToolBarArea___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ToolBarAreas >::toPython(
        Shiboken::Converter< ::Qt::ToolBarAreas>::toCpp(self)
        & Shiboken::Converter< ::Qt::ToolBarAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ToolBarAreas >::toPython(
        Shiboken::Converter< ::Qt::ToolBarAreas>::toCpp(self)
        | Shiboken::Converter< ::Qt::ToolBarAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ToolBarAreas >::toPython(
        Shiboken::Converter< ::Qt::ToolBarAreas>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::ToolBarAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::ToolBarAreas >::toPython(
        ~Shiboken::Converter< ::Qt::ToolBarAreas >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_ToolBarArea_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ToolBarAreas>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_ToolBarArea__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ToolBarAreas>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_ToolBarArea_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_ToolBarArea__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_ToolBarArea_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_ToolBarArea_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ToolBarAreas_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "ToolBarAreas",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ToolBarArea_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Alignment >::toPython(
        Shiboken::Converter< ::Qt::Alignment>::toCpp(self)
        & Shiboken::Converter< ::Qt::Alignment >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Alignment >::toPython(
        Shiboken::Converter< ::Qt::Alignment>::toCpp(self)
        | Shiboken::Converter< ::Qt::Alignment >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Alignment >::toPython(
        Shiboken::Converter< ::Qt::Alignment>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::Alignment >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::Alignment >::toPython(
        ~Shiboken::Converter< ::Qt::Alignment >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_AlignmentFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::Alignment>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_AlignmentFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::Alignment>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_AlignmentFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_AlignmentFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_AlignmentFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_AlignmentFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_Alignment_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "Alignment",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_AlignmentFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter< ::Qt::DockWidgetAreas>::toCpp(self)
        & Shiboken::Converter< ::Qt::DockWidgetAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter< ::Qt::DockWidgetAreas>::toCpp(self)
        | Shiboken::Converter< ::Qt::DockWidgetAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter< ::Qt::DockWidgetAreas>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::DockWidgetAreas >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::DockWidgetAreas >::toPython(
        ~Shiboken::Converter< ::Qt::DockWidgetAreas >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_DockWidgetArea_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::DockWidgetAreas>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_DockWidgetArea__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::DockWidgetAreas>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_DockWidgetArea_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_DockWidgetArea__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_DockWidgetArea_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_DockWidgetArea_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_DockWidgetAreas_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "DockWidgetAreas",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_DockWidgetArea_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter< ::Qt::KeyboardModifiers>::toCpp(self)
        & Shiboken::Converter< ::Qt::KeyboardModifiers >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter< ::Qt::KeyboardModifiers>::toCpp(self)
        | Shiboken::Converter< ::Qt::KeyboardModifiers >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter< ::Qt::KeyboardModifiers>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::KeyboardModifiers >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::KeyboardModifiers >::toPython(
        ~Shiboken::Converter< ::Qt::KeyboardModifiers >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_KeyboardModifier_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::KeyboardModifiers>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_KeyboardModifier__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::KeyboardModifiers>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_KeyboardModifier_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_KeyboardModifier__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_KeyboardModifier_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_KeyboardModifier_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_KeyboardModifiers_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "KeyboardModifiers",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_KeyboardModifier_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_InputMethodHint___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::InputMethodHints >::toPython(
        Shiboken::Converter< ::Qt::InputMethodHints>::toCpp(self)
        & Shiboken::Converter< ::Qt::InputMethodHints >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::InputMethodHints >::toPython(
        Shiboken::Converter< ::Qt::InputMethodHints>::toCpp(self)
        | Shiboken::Converter< ::Qt::InputMethodHints >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::InputMethodHints >::toPython(
        Shiboken::Converter< ::Qt::InputMethodHints>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::InputMethodHints >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::InputMethodHints >::toPython(
        ~Shiboken::Converter< ::Qt::InputMethodHints >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_InputMethodHint_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::InputMethodHints>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_InputMethodHint__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::InputMethodHints>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_InputMethodHint_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_InputMethodHint__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_InputMethodHint_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_InputMethodHint_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_InputMethodHints_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "InputMethodHints",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_InputMethodHint_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ItemFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ItemFlags >::toPython(
        Shiboken::Converter< ::Qt::ItemFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::ItemFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ItemFlags >::toPython(
        Shiboken::Converter< ::Qt::ItemFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::ItemFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::ItemFlags >::toPython(
        Shiboken::Converter< ::Qt::ItemFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::ItemFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::ItemFlags >::toPython(
        ~Shiboken::Converter< ::Qt::ItemFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_ItemFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ItemFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_ItemFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::ItemFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_ItemFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_ItemFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ItemFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_ItemFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_ItemFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ItemFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "ItemFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ItemFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_Orientation___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Orientations >::toPython(
        Shiboken::Converter< ::Qt::Orientations>::toCpp(self)
        & Shiboken::Converter< ::Qt::Orientations >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Orientations >::toPython(
        Shiboken::Converter< ::Qt::Orientations>::toCpp(self)
        | Shiboken::Converter< ::Qt::Orientations >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::Orientations >::toPython(
        Shiboken::Converter< ::Qt::Orientations>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::Orientations >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::Orientations >::toPython(
        ~Shiboken::Converter< ::Qt::Orientations >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_Orientation_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::Orientations>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_Orientation__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::Orientations>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_Orientation_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_Orientation__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_Orientation___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_Orientation___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_Orientation___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_Orientation___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_Orientation_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_Orientation_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_Orientations_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "Orientations",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_Orientation_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_WindowState___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowStates >::toPython(
        Shiboken::Converter< ::Qt::WindowStates>::toCpp(self)
        & Shiboken::Converter< ::Qt::WindowStates >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowStates >::toPython(
        Shiboken::Converter< ::Qt::WindowStates>::toCpp(self)
        | Shiboken::Converter< ::Qt::WindowStates >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::WindowStates >::toPython(
        Shiboken::Converter< ::Qt::WindowStates>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::WindowStates >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::WindowStates >::toPython(
        ~Shiboken::Converter< ::Qt::WindowStates >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_WindowState_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::WindowStates>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_WindowState__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::WindowStates>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_WindowState_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_WindowState__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_WindowState___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowState___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowState___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_WindowState___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_WindowState_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_WindowState_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_WindowStates_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "WindowStates",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_WindowState_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter< ::Qt::TextInteractionFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::TextInteractionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter< ::Qt::TextInteractionFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::TextInteractionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter< ::Qt::TextInteractionFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::TextInteractionFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::TextInteractionFlags >::toPython(
        ~Shiboken::Converter< ::Qt::TextInteractionFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::TextInteractionFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_TextInteractionFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::TextInteractionFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_TextInteractionFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_TextInteractionFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_TextInteractionFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_TextInteractionFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_TextInteractionFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "TextInteractionFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_TextInteractionFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_MouseButton___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MouseButtons >::toPython(
        Shiboken::Converter< ::Qt::MouseButtons>::toCpp(self)
        & Shiboken::Converter< ::Qt::MouseButtons >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MouseButtons >::toPython(
        Shiboken::Converter< ::Qt::MouseButtons>::toCpp(self)
        | Shiboken::Converter< ::Qt::MouseButtons >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MouseButtons >::toPython(
        Shiboken::Converter< ::Qt::MouseButtons>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::MouseButtons >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::MouseButtons >::toPython(
        ~Shiboken::Converter< ::Qt::MouseButtons >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_MouseButton_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::MouseButtons>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_MouseButton__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::MouseButtons>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_MouseButton_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_MouseButton__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_MouseButton___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_MouseButton_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_MouseButton_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_MouseButtons_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "MouseButtons",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_MouseButton_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_MatchFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MatchFlags >::toPython(
        Shiboken::Converter< ::Qt::MatchFlags>::toCpp(self)
        & Shiboken::Converter< ::Qt::MatchFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MatchFlags >::toPython(
        Shiboken::Converter< ::Qt::MatchFlags>::toCpp(self)
        | Shiboken::Converter< ::Qt::MatchFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::Qt::MatchFlags >::toPython(
        Shiboken::Converter< ::Qt::MatchFlags>::toCpp(self)
        ^ Shiboken::Converter< ::Qt::MatchFlags >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< Qt::MatchFlags >::toPython(
        ~Shiboken::Converter< ::Qt::MatchFlags >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_Qt_MatchFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::MatchFlags>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_Qt_MatchFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::Qt::MatchFlags>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_Qt_MatchFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_Qt_MatchFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_MatchFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_Qt_MatchFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_Qt_MatchFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_MatchFlags_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "MatchFlags",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_MatchFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_Qt(PyObject* module)
{
    SbkPySide_QtCoreTypes[SBK_QT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_Qt_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "Qt", "Qt",
        &Sbk_Qt_Type)) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'ShortcutContext'.
    SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ShortcutContext",
        "PySide.QtCore.Qt.ShortcutContext",
        "Qt::ShortcutContext");
    if (!SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX],
        &Sbk_Qt_Type, "WidgetShortcut", (long) Qt::WidgetShortcut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX],
        &Sbk_Qt_Type, "WindowShortcut", (long) Qt::WindowShortcut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX],
        &Sbk_Qt_Type, "ApplicationShortcut", (long) Qt::ApplicationShortcut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX],
        &Sbk_Qt_Type, "WidgetWithChildrenShortcut", (long) Qt::WidgetWithChildrenShortcut))
        return ;
    // End of 'ShortcutContext' enum.

    // Initialization of enum 'CheckState'.
    SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "CheckState",
        "PySide.QtCore.Qt.CheckState",
        "Qt::CheckState");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX],
        &Sbk_Qt_Type, "Unchecked", (long) Qt::Unchecked))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX],
        &Sbk_Qt_Type, "PartiallyChecked", (long) Qt::PartiallyChecked))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX],
        &Sbk_Qt_Type, "Checked", (long) Qt::Checked))
        return ;
    // End of 'CheckState' enum.

    // Initialization of enum 'FocusPolicy'.
    SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "FocusPolicy",
        "PySide.QtCore.Qt.FocusPolicy",
        "Qt::FocusPolicy");
    if (!SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX],
        &Sbk_Qt_Type, "NoFocus", (long) Qt::NoFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX],
        &Sbk_Qt_Type, "TabFocus", (long) Qt::TabFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX],
        &Sbk_Qt_Type, "ClickFocus", (long) Qt::ClickFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX],
        &Sbk_Qt_Type, "StrongFocus", (long) Qt::StrongFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX],
        &Sbk_Qt_Type, "WheelFocus", (long) Qt::WheelFocus))
        return ;
    // End of 'FocusPolicy' enum.

    // Initialization of enum 'GestureType'.
    SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "GestureType",
        "PySide.QtCore.Qt.GestureType",
        "Qt::GestureType");
    if (!SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "TapGesture", (long) Qt::TapGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "TapAndHoldGesture", (long) Qt::TapAndHoldGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "PanGesture", (long) Qt::PanGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "PinchGesture", (long) Qt::PinchGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "SwipeGesture", (long) Qt::SwipeGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "CustomGesture", (long) Qt::CustomGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX],
        &Sbk_Qt_Type, "LastGestureType", (long) Qt::LastGestureType))
        return ;
    // End of 'GestureType' enum.

    // Initialization of enum 'DropAction'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DROPACTION__IDX] = &SbkPySide_QtCore_Qt_DropActions_Type;
    SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "DropAction",
        "PySide.QtCore.Qt.DropAction",
        "Qt::DropAction",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DROPACTION__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "CopyAction", (long) Qt::CopyAction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "MoveAction", (long) Qt::MoveAction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "LinkAction", (long) Qt::LinkAction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "ActionMask", (long) Qt::ActionMask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "TargetMoveAction", (long) Qt::TargetMoveAction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX],
        &Sbk_Qt_Type, "IgnoreAction", (long) Qt::IgnoreAction))
        return ;
    // End of 'DropAction' enum.

    // Initialization of enum 'WindowType'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWTYPE__IDX] = &SbkPySide_QtCore_Qt_WindowFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WindowType",
        "PySide.QtCore.Qt.WindowType",
        "Qt::WindowType",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWTYPE__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Widget", (long) Qt::Widget))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Window", (long) Qt::Window))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Dialog", (long) Qt::Dialog))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Sheet", (long) Qt::Sheet))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Drawer", (long) Qt::Drawer))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Popup", (long) Qt::Popup))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Tool", (long) Qt::Tool))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "ToolTip", (long) Qt::ToolTip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "SplashScreen", (long) Qt::SplashScreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "Desktop", (long) Qt::Desktop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "SubWindow", (long) Qt::SubWindow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowType_Mask", (long) Qt::WindowType_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "MSWindowsFixedSizeDialogHint", (long) Qt::MSWindowsFixedSizeDialogHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "MSWindowsOwnDC", (long) Qt::MSWindowsOwnDC))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "X11BypassWindowManagerHint", (long) Qt::X11BypassWindowManagerHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "FramelessWindowHint", (long) Qt::FramelessWindowHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowTitleHint", (long) Qt::WindowTitleHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowSystemMenuHint", (long) Qt::WindowSystemMenuHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowMinimizeButtonHint", (long) Qt::WindowMinimizeButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowMaximizeButtonHint", (long) Qt::WindowMaximizeButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowMinMaxButtonsHint", (long) Qt::WindowMinMaxButtonsHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowContextHelpButtonHint", (long) Qt::WindowContextHelpButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowShadeButtonHint", (long) Qt::WindowShadeButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowStaysOnTopHint", (long) Qt::WindowStaysOnTopHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "CustomizeWindowHint", (long) Qt::CustomizeWindowHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowStaysOnBottomHint", (long) Qt::WindowStaysOnBottomHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowCloseButtonHint", (long) Qt::WindowCloseButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "MacWindowToolBarButtonHint", (long) Qt::MacWindowToolBarButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "BypassGraphicsProxyWidget", (long) Qt::BypassGraphicsProxyWidget))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowOkButtonHint", (long) Qt::WindowOkButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowCancelButtonHint", (long) Qt::WindowCancelButtonHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowSoftkeysVisibleHint", (long) Qt::WindowSoftkeysVisibleHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX],
        &Sbk_Qt_Type, "WindowSoftkeysRespondHint", (long) Qt::WindowSoftkeysRespondHint))
        return ;
    // End of 'WindowType' enum.

    // Initialization of enum 'DateFormat'.
    SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "DateFormat",
        "PySide.QtCore.Qt.DateFormat",
        "Qt::DateFormat");
    if (!SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "TextDate", (long) Qt::TextDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "ISODate", (long) Qt::ISODate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "SystemLocaleDate", (long) Qt::SystemLocaleDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "LocalDate", (long) Qt::LocalDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "LocaleDate", (long) Qt::LocaleDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "SystemLocaleShortDate", (long) Qt::SystemLocaleShortDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "SystemLocaleLongDate", (long) Qt::SystemLocaleLongDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "DefaultLocaleShortDate", (long) Qt::DefaultLocaleShortDate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX],
        &Sbk_Qt_Type, "DefaultLocaleLongDate", (long) Qt::DefaultLocaleLongDate))
        return ;
    // End of 'DateFormat' enum.

    // Initialization of enum 'TextFormat'.
    SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TextFormat",
        "PySide.QtCore.Qt.TextFormat",
        "Qt::TextFormat");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX],
        &Sbk_Qt_Type, "PlainText", (long) Qt::PlainText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX],
        &Sbk_Qt_Type, "RichText", (long) Qt::RichText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX],
        &Sbk_Qt_Type, "AutoText", (long) Qt::AutoText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX],
        &Sbk_Qt_Type, "LogText", (long) Qt::LogText))
        return ;
    // End of 'TextFormat' enum.

    // Initialization of enum 'PenJoinStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "PenJoinStyle",
        "PySide.QtCore.Qt.PenJoinStyle",
        "Qt::PenJoinStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX],
        &Sbk_Qt_Type, "MiterJoin", (long) Qt::MiterJoin))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX],
        &Sbk_Qt_Type, "BevelJoin", (long) Qt::BevelJoin))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX],
        &Sbk_Qt_Type, "RoundJoin", (long) Qt::RoundJoin))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX],
        &Sbk_Qt_Type, "SvgMiterJoin", (long) Qt::SvgMiterJoin))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX],
        &Sbk_Qt_Type, "MPenJoinStyle", (long) Qt::MPenJoinStyle))
        return ;
    // End of 'PenJoinStyle' enum.

    // Initialization of enum 'GestureFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_GESTUREFLAG__IDX] = &SbkPySide_QtCore_Qt_GestureFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "GestureFlag",
        "PySide.QtCore.Qt.GestureFlag",
        "Qt::GestureFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_GESTUREFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX],
        &Sbk_Qt_Type, "DontStartGestureOnChildren", (long) Qt::DontStartGestureOnChildren))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX],
        &Sbk_Qt_Type, "ReceivePartialGestures", (long) Qt::ReceivePartialGestures))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX],
        &Sbk_Qt_Type, "IgnoredGesturesPropagateToParent", (long) Qt::IgnoredGesturesPropagateToParent))
        return ;
    // End of 'GestureFlag' enum.

    // Initialization of enum 'CaseSensitivity'.
    SbkPySide_QtCoreTypes[SBK_QT_CASESENSITIVITY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "CaseSensitivity",
        "PySide.QtCore.Qt.CaseSensitivity",
        "Qt::CaseSensitivity");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CASESENSITIVITY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CASESENSITIVITY_IDX],
        &Sbk_Qt_Type, "CaseInsensitive", (long) Qt::CaseInsensitive))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CASESENSITIVITY_IDX],
        &Sbk_Qt_Type, "CaseSensitive", (long) Qt::CaseSensitive))
        return ;
    // End of 'CaseSensitivity' enum.

    // Initialization of enum 'EventPriority'.
    SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "EventPriority",
        "PySide.QtCore.Qt.EventPriority",
        "Qt::EventPriority");
    if (!SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX],
        &Sbk_Qt_Type, "HighEventPriority", (long) Qt::HighEventPriority))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX],
        &Sbk_Qt_Type, "NormalEventPriority", (long) Qt::NormalEventPriority))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX],
        &Sbk_Qt_Type, "LowEventPriority", (long) Qt::LowEventPriority))
        return ;
    // End of 'EventPriority' enum.

    // Initialization of enum 'ImageConversionFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_IMAGECONVERSIONFLAG__IDX] = &SbkPySide_QtCore_Qt_ImageConversionFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ImageConversionFlag",
        "PySide.QtCore.Qt.ImageConversionFlag",
        "Qt::ImageConversionFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_IMAGECONVERSIONFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "ColorMode_Mask", (long) Qt::ColorMode_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "AutoColor", (long) Qt::AutoColor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "ColorOnly", (long) Qt::ColorOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "MonoOnly", (long) Qt::MonoOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "AlphaDither_Mask", (long) Qt::AlphaDither_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "ThresholdAlphaDither", (long) Qt::ThresholdAlphaDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "OrderedAlphaDither", (long) Qt::OrderedAlphaDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "DiffuseAlphaDither", (long) Qt::DiffuseAlphaDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "NoAlpha", (long) Qt::NoAlpha))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "Dither_Mask", (long) Qt::Dither_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "DiffuseDither", (long) Qt::DiffuseDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "OrderedDither", (long) Qt::OrderedDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "ThresholdDither", (long) Qt::ThresholdDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "DitherMode_Mask", (long) Qt::DitherMode_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "AutoDither", (long) Qt::AutoDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "PreferDither", (long) Qt::PreferDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "AvoidDither", (long) Qt::AvoidDither))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "NoOpaqueDetection", (long) Qt::NoOpaqueDetection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX],
        &Sbk_Qt_Type, "NoFormatConversion", (long) Qt::NoFormatConversion))
        return ;
    // End of 'ImageConversionFlag' enum.

    // Initialization of enum 'CursorMoveStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_CURSORMOVESTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "CursorMoveStyle",
        "PySide.QtCore.Qt.CursorMoveStyle",
        "Qt::CursorMoveStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CURSORMOVESTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORMOVESTYLE_IDX],
        &Sbk_Qt_Type, "LogicalMoveStyle", (long) Qt::LogicalMoveStyle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORMOVESTYLE_IDX],
        &Sbk_Qt_Type, "VisualMoveStyle", (long) Qt::VisualMoveStyle))
        return ;
    // End of 'CursorMoveStyle' enum.

    // Initialization of enum 'GestureState'.
    SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "GestureState",
        "PySide.QtCore.Qt.GestureState",
        "Qt::GestureState");
    if (!SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX],
        &Sbk_Qt_Type, "NoGesture", (long) Qt::NoGesture))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX],
        &Sbk_Qt_Type, "GestureStarted", (long) Qt::GestureStarted))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX],
        &Sbk_Qt_Type, "GestureUpdated", (long) Qt::GestureUpdated))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX],
        &Sbk_Qt_Type, "GestureFinished", (long) Qt::GestureFinished))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX],
        &Sbk_Qt_Type, "GestureCanceled", (long) Qt::GestureCanceled))
        return ;
    // End of 'GestureState' enum.

    // Initialization of enum 'BGMode'.
    SbkPySide_QtCoreTypes[SBK_QT_BGMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "BGMode",
        "PySide.QtCore.Qt.BGMode",
        "Qt::BGMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_BGMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BGMODE_IDX],
        &Sbk_Qt_Type, "TransparentMode", (long) Qt::TransparentMode))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BGMODE_IDX],
        &Sbk_Qt_Type, "OpaqueMode", (long) Qt::OpaqueMode))
        return ;
    // End of 'BGMode' enum.

    // Initialization of enum 'ConnectionType'.
    SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ConnectionType",
        "PySide.QtCore.Qt.ConnectionType",
        "Qt::ConnectionType");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "AutoConnection", (long) Qt::AutoConnection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "DirectConnection", (long) Qt::DirectConnection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "QueuedConnection", (long) Qt::QueuedConnection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "AutoCompatConnection", (long) Qt::AutoCompatConnection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "BlockingQueuedConnection", (long) Qt::BlockingQueuedConnection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX],
        &Sbk_Qt_Type, "UniqueConnection", (long) Qt::UniqueConnection))
        return ;
    // End of 'ConnectionType' enum.

    // Initialization of enum 'ToolBarArea'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TOOLBARAREA__IDX] = &SbkPySide_QtCore_Qt_ToolBarAreas_Type;
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ToolBarArea",
        "PySide.QtCore.Qt.ToolBarArea",
        "Qt::ToolBarArea",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TOOLBARAREA__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "LeftToolBarArea", (long) Qt::LeftToolBarArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "RightToolBarArea", (long) Qt::RightToolBarArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "TopToolBarArea", (long) Qt::TopToolBarArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "BottomToolBarArea", (long) Qt::BottomToolBarArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "ToolBarArea_Mask", (long) Qt::ToolBarArea_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "AllToolBarAreas", (long) Qt::AllToolBarAreas))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX],
        &Sbk_Qt_Type, "NoToolBarArea", (long) Qt::NoToolBarArea))
        return ;
    // End of 'ToolBarArea' enum.

    // Initialization of enum 'CoordinateSystem'.
    SbkPySide_QtCoreTypes[SBK_QT_COORDINATESYSTEM_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "CoordinateSystem",
        "PySide.QtCore.Qt.CoordinateSystem",
        "Qt::CoordinateSystem");
    if (!SbkPySide_QtCoreTypes[SBK_QT_COORDINATESYSTEM_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_COORDINATESYSTEM_IDX],
        &Sbk_Qt_Type, "DeviceCoordinates", (long) Qt::DeviceCoordinates))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_COORDINATESYSTEM_IDX],
        &Sbk_Qt_Type, "LogicalCoordinates", (long) Qt::LogicalCoordinates))
        return ;
    // End of 'CoordinateSystem' enum.

    // Initialization of enum 'SizeMode'.
    SbkPySide_QtCoreTypes[SBK_QT_SIZEMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "SizeMode",
        "PySide.QtCore.Qt.SizeMode",
        "Qt::SizeMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_SIZEMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEMODE_IDX],
        &Sbk_Qt_Type, "AbsoluteSize", (long) Qt::AbsoluteSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEMODE_IDX],
        &Sbk_Qt_Type, "RelativeSize", (long) Qt::RelativeSize))
        return ;
    // End of 'SizeMode' enum.

    // Initialization of enum 'FocusReason'.
    SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "FocusReason",
        "PySide.QtCore.Qt.FocusReason",
        "Qt::FocusReason");
    if (!SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "MouseFocusReason", (long) Qt::MouseFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "TabFocusReason", (long) Qt::TabFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "BacktabFocusReason", (long) Qt::BacktabFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "ActiveWindowFocusReason", (long) Qt::ActiveWindowFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "PopupFocusReason", (long) Qt::PopupFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "ShortcutFocusReason", (long) Qt::ShortcutFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "MenuBarFocusReason", (long) Qt::MenuBarFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "OtherFocusReason", (long) Qt::OtherFocusReason))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX],
        &Sbk_Qt_Type, "NoFocusReason", (long) Qt::NoFocusReason))
        return ;
    // End of 'FocusReason' enum.

    // Initialization of enum 'Modifier'.
    SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "Modifier",
        "PySide.QtCore.Qt.Modifier",
        "Qt::Modifier");
    if (!SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "META", (long) Qt::META))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "SHIFT", (long) Qt::SHIFT))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "CTRL", (long) Qt::CTRL))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "ALT", (long) Qt::ALT))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "MODIFIER_MASK", (long) Qt::MODIFIER_MASK))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX],
        &Sbk_Qt_Type, "UNICODE_ACCEL", (long) Qt::UNICODE_ACCEL))
        return ;
    // End of 'Modifier' enum.

    // Initialization of enum 'TileRule'.
    SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TileRule",
        "PySide.QtCore.Qt.TileRule",
        "Qt::TileRule");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX],
        &Sbk_Qt_Type, "StretchTile", (long) Qt::StretchTile))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX],
        &Sbk_Qt_Type, "RepeatTile", (long) Qt::RepeatTile))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX],
        &Sbk_Qt_Type, "RoundTile", (long) Qt::RoundTile))
        return ;
    // End of 'TileRule' enum.

    // Initialization of enum 'WhiteSpaceMode'.
    SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WhiteSpaceMode",
        "PySide.QtCore.Qt.WhiteSpaceMode",
        "Qt::WhiteSpaceMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX],
        &Sbk_Qt_Type, "WhiteSpaceNormal", (long) Qt::WhiteSpaceNormal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX],
        &Sbk_Qt_Type, "WhiteSpacePre", (long) Qt::WhiteSpacePre))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX],
        &Sbk_Qt_Type, "WhiteSpaceNoWrap", (long) Qt::WhiteSpaceNoWrap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX],
        &Sbk_Qt_Type, "WhiteSpaceModeUndefined", (long) Qt::WhiteSpaceModeUndefined))
        return ;
    // End of 'WhiteSpaceMode' enum.

    // Initialization of enum 'AspectRatioMode'.
    SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "AspectRatioMode",
        "PySide.QtCore.Qt.AspectRatioMode",
        "Qt::AspectRatioMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX],
        &Sbk_Qt_Type, "IgnoreAspectRatio", (long) Qt::IgnoreAspectRatio))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX],
        &Sbk_Qt_Type, "KeepAspectRatio", (long) Qt::KeepAspectRatio))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX],
        &Sbk_Qt_Type, "KeepAspectRatioByExpanding", (long) Qt::KeepAspectRatioByExpanding))
        return ;
    // End of 'AspectRatioMode' enum.

    // Initialization of enum 'SizeHint'.
    SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "SizeHint",
        "PySide.QtCore.Qt.SizeHint",
        "Qt::SizeHint");
    if (!SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX],
        &Sbk_Qt_Type, "MinimumSize", (long) Qt::MinimumSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX],
        &Sbk_Qt_Type, "PreferredSize", (long) Qt::PreferredSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX],
        &Sbk_Qt_Type, "MaximumSize", (long) Qt::MaximumSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX],
        &Sbk_Qt_Type, "MinimumDescent", (long) Qt::MinimumDescent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX],
        &Sbk_Qt_Type, "NSizeHints", (long) Qt::NSizeHints))
        return ;
    // End of 'SizeHint' enum.

    // Initialization of enum 'AlignmentFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ALIGNMENTFLAG__IDX] = &SbkPySide_QtCore_Qt_Alignment_Type;
    SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "AlignmentFlag",
        "PySide.QtCore.Qt.AlignmentFlag",
        "Qt::AlignmentFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ALIGNMENTFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignLeft", (long) Qt::AlignLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignLeading", (long) Qt::AlignLeading))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignRight", (long) Qt::AlignRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignTrailing", (long) Qt::AlignTrailing))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignHCenter", (long) Qt::AlignHCenter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignJustify", (long) Qt::AlignJustify))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignAbsolute", (long) Qt::AlignAbsolute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignHorizontal_Mask", (long) Qt::AlignHorizontal_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignTop", (long) Qt::AlignTop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignBottom", (long) Qt::AlignBottom))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignVCenter", (long) Qt::AlignVCenter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignVertical_Mask", (long) Qt::AlignVertical_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX],
        &Sbk_Qt_Type, "AlignCenter", (long) Qt::AlignCenter))
        return ;
    // End of 'AlignmentFlag' enum.

    // Initialization of enum 'ContextMenuPolicy'.
    SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ContextMenuPolicy",
        "PySide.QtCore.Qt.ContextMenuPolicy",
        "Qt::ContextMenuPolicy");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX],
        &Sbk_Qt_Type, "NoContextMenu", (long) Qt::NoContextMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX],
        &Sbk_Qt_Type, "DefaultContextMenu", (long) Qt::DefaultContextMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX],
        &Sbk_Qt_Type, "ActionsContextMenu", (long) Qt::ActionsContextMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX],
        &Sbk_Qt_Type, "CustomContextMenu", (long) Qt::CustomContextMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX],
        &Sbk_Qt_Type, "PreventContextMenu", (long) Qt::PreventContextMenu))
        return ;
    // End of 'ContextMenuPolicy' enum.

    // Initialization of enum 'DockWidgetArea'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DOCKWIDGETAREA__IDX] = &SbkPySide_QtCore_Qt_DockWidgetAreas_Type;
    SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "DockWidgetArea",
        "PySide.QtCore.Qt.DockWidgetArea",
        "Qt::DockWidgetArea",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DOCKWIDGETAREA__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "LeftDockWidgetArea", (long) Qt::LeftDockWidgetArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "RightDockWidgetArea", (long) Qt::RightDockWidgetArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "TopDockWidgetArea", (long) Qt::TopDockWidgetArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "BottomDockWidgetArea", (long) Qt::BottomDockWidgetArea))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "DockWidgetArea_Mask", (long) Qt::DockWidgetArea_Mask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "AllDockWidgetAreas", (long) Qt::AllDockWidgetAreas))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX],
        &Sbk_Qt_Type, "NoDockWidgetArea", (long) Qt::NoDockWidgetArea))
        return ;
    // End of 'DockWidgetArea' enum.

    // Initialization of enum 'UIEffect'.
    SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "UIEffect",
        "PySide.QtCore.Qt.UIEffect",
        "Qt::UIEffect");
    if (!SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_General", (long) Qt::UI_General))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_AnimateMenu", (long) Qt::UI_AnimateMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_FadeMenu", (long) Qt::UI_FadeMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_AnimateCombo", (long) Qt::UI_AnimateCombo))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_AnimateTooltip", (long) Qt::UI_AnimateTooltip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_FadeTooltip", (long) Qt::UI_FadeTooltip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX],
        &Sbk_Qt_Type, "UI_AnimateToolBox", (long) Qt::UI_AnimateToolBox))
        return ;
    // End of 'UIEffect' enum.

    // Initialization of enum 'AnchorPoint'.
    SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "AnchorPoint",
        "PySide.QtCore.Qt.AnchorPoint",
        "Qt::AnchorPoint");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorLeft", (long) Qt::AnchorLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorHorizontalCenter", (long) Qt::AnchorHorizontalCenter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorRight", (long) Qt::AnchorRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorTop", (long) Qt::AnchorTop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorVerticalCenter", (long) Qt::AnchorVerticalCenter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX],
        &Sbk_Qt_Type, "AnchorBottom", (long) Qt::AnchorBottom))
        return ;
    // End of 'AnchorPoint' enum.

    // Initialization of enum 'GlobalColor'.
    SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "GlobalColor",
        "PySide.QtCore.Qt.GlobalColor",
        "Qt::GlobalColor");
    if (!SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "color0", (long) Qt::color0))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "color1", (long) Qt::color1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "black", (long) Qt::black))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "white", (long) Qt::white))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkGray", (long) Qt::darkGray))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "gray", (long) Qt::gray))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "lightGray", (long) Qt::lightGray))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "red", (long) Qt::red))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "green", (long) Qt::green))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "blue", (long) Qt::blue))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "cyan", (long) Qt::cyan))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "magenta", (long) Qt::magenta))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "yellow", (long) Qt::yellow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkRed", (long) Qt::darkRed))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkGreen", (long) Qt::darkGreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkBlue", (long) Qt::darkBlue))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkCyan", (long) Qt::darkCyan))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkMagenta", (long) Qt::darkMagenta))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "darkYellow", (long) Qt::darkYellow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX],
        &Sbk_Qt_Type, "transparent", (long) Qt::transparent))
        return ;
    // End of 'GlobalColor' enum.

    // Initialization of enum 'KeyboardModifier'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_KEYBOARDMODIFIER__IDX] = &SbkPySide_QtCore_Qt_KeyboardModifiers_Type;
    SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "KeyboardModifier",
        "PySide.QtCore.Qt.KeyboardModifier",
        "Qt::KeyboardModifier",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_KEYBOARDMODIFIER__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "NoModifier", (long) Qt::NoModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "ShiftModifier", (long) Qt::ShiftModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "ControlModifier", (long) Qt::ControlModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "AltModifier", (long) Qt::AltModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "MetaModifier", (long) Qt::MetaModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "KeypadModifier", (long) Qt::KeypadModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "GroupSwitchModifier", (long) Qt::GroupSwitchModifier))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX],
        &Sbk_Qt_Type, "KeyboardModifierMask", (long) Qt::KeyboardModifierMask))
        return ;
    // End of 'KeyboardModifier' enum.

    // Initialization of enum 'NavigationMode'.
    SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "NavigationMode",
        "PySide.QtCore.Qt.NavigationMode",
        "Qt::NavigationMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX],
        &Sbk_Qt_Type, "NavigationModeNone", (long) Qt::NavigationModeNone))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX],
        &Sbk_Qt_Type, "NavigationModeKeypadTabOrder", (long) Qt::NavigationModeKeypadTabOrder))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX],
        &Sbk_Qt_Type, "NavigationModeKeypadDirectional", (long) Qt::NavigationModeKeypadDirectional))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX],
        &Sbk_Qt_Type, "NavigationModeCursorAuto", (long) Qt::NavigationModeCursorAuto))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX],
        &Sbk_Qt_Type, "NavigationModeCursorForceVisible", (long) Qt::NavigationModeCursorForceVisible))
        return ;
    // End of 'NavigationMode' enum.

    // Initialization of enum 'ItemDataRole'.
    SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ItemDataRole",
        "PySide.QtCore.Qt.ItemDataRole",
        "Qt::ItemDataRole");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "DisplayRole", (long) Qt::DisplayRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "DecorationRole", (long) Qt::DecorationRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "EditRole", (long) Qt::EditRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "ToolTipRole", (long) Qt::ToolTipRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "StatusTipRole", (long) Qt::StatusTipRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "WhatsThisRole", (long) Qt::WhatsThisRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "FontRole", (long) Qt::FontRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "TextAlignmentRole", (long) Qt::TextAlignmentRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "BackgroundColorRole", (long) Qt::BackgroundColorRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "BackgroundRole", (long) Qt::BackgroundRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "TextColorRole", (long) Qt::TextColorRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "ForegroundRole", (long) Qt::ForegroundRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "CheckStateRole", (long) Qt::CheckStateRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "AccessibleTextRole", (long) Qt::AccessibleTextRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "AccessibleDescriptionRole", (long) Qt::AccessibleDescriptionRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "SizeHintRole", (long) Qt::SizeHintRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "InitialSortOrderRole", (long) Qt::InitialSortOrderRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "DisplayPropertyRole", (long) Qt::DisplayPropertyRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "DecorationPropertyRole", (long) Qt::DecorationPropertyRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "ToolTipPropertyRole", (long) Qt::ToolTipPropertyRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "StatusTipPropertyRole", (long) Qt::StatusTipPropertyRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "WhatsThisPropertyRole", (long) Qt::WhatsThisPropertyRole))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX],
        &Sbk_Qt_Type, "UserRole", (long) Qt::UserRole))
        return ;
    // End of 'ItemDataRole' enum.

    // Initialization of enum 'ScrollBarPolicy'.
    SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ScrollBarPolicy",
        "PySide.QtCore.Qt.ScrollBarPolicy",
        "Qt::ScrollBarPolicy");
    if (!SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX],
        &Sbk_Qt_Type, "ScrollBarAsNeeded", (long) Qt::ScrollBarAsNeeded))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX],
        &Sbk_Qt_Type, "ScrollBarAlwaysOff", (long) Qt::ScrollBarAlwaysOff))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX],
        &Sbk_Qt_Type, "ScrollBarAlwaysOn", (long) Qt::ScrollBarAlwaysOn))
        return ;
    // End of 'ScrollBarPolicy' enum.

    // Initialization of enum 'InputMethodHint'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_INPUTMETHODHINT__IDX] = &SbkPySide_QtCore_Qt_InputMethodHints_Type;
    SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "InputMethodHint",
        "PySide.QtCore.Qt.InputMethodHint",
        "Qt::InputMethodHint",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_INPUTMETHODHINT__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhNone", (long) Qt::ImhNone))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhHiddenText", (long) Qt::ImhHiddenText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhNoAutoUppercase", (long) Qt::ImhNoAutoUppercase))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhPreferNumbers", (long) Qt::ImhPreferNumbers))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhPreferUppercase", (long) Qt::ImhPreferUppercase))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhPreferLowercase", (long) Qt::ImhPreferLowercase))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhNoPredictiveText", (long) Qt::ImhNoPredictiveText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhDigitsOnly", (long) Qt::ImhDigitsOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhFormattedNumbersOnly", (long) Qt::ImhFormattedNumbersOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhUppercaseOnly", (long) Qt::ImhUppercaseOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhLowercaseOnly", (long) Qt::ImhLowercaseOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhDialableCharactersOnly", (long) Qt::ImhDialableCharactersOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhEmailCharactersOnly", (long) Qt::ImhEmailCharactersOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhUrlCharactersOnly", (long) Qt::ImhUrlCharactersOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX],
        &Sbk_Qt_Type, "ImhExclusiveInputMask", (long) Qt::ImhExclusiveInputMask))
        return ;
    // End of 'InputMethodHint' enum.

    // Initialization of enum 'AnchorAttribute'.
    SbkPySide_QtCoreTypes[SBK_QT_ANCHORATTRIBUTE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "AnchorAttribute",
        "PySide.QtCore.Qt.AnchorAttribute",
        "Qt::AnchorAttribute");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ANCHORATTRIBUTE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AnchorName", (long) Qt::AnchorName))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ANCHORATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AnchorHref", (long) Qt::AnchorHref))
        return ;
    // End of 'AnchorAttribute' enum.

    // Initialization of enum 'WindowModality'.
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WindowModality",
        "PySide.QtCore.Qt.WindowModality",
        "Qt::WindowModality");
    if (!SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX],
        &Sbk_Qt_Type, "NonModal", (long) Qt::NonModal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX],
        &Sbk_Qt_Type, "WindowModal", (long) Qt::WindowModal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX],
        &Sbk_Qt_Type, "ApplicationModal", (long) Qt::ApplicationModal))
        return ;
    // End of 'WindowModality' enum.

    // Initialization of enum 'SortOrder'.
    SbkPySide_QtCoreTypes[SBK_QT_SORTORDER_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "SortOrder",
        "PySide.QtCore.Qt.SortOrder",
        "Qt::SortOrder");
    if (!SbkPySide_QtCoreTypes[SBK_QT_SORTORDER_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SORTORDER_IDX],
        &Sbk_Qt_Type, "AscendingOrder", (long) Qt::AscendingOrder))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_SORTORDER_IDX],
        &Sbk_Qt_Type, "DescendingOrder", (long) Qt::DescendingOrder))
        return ;
    // End of 'SortOrder' enum.

    // Initialization of enum 'PenStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "PenStyle",
        "PySide.QtCore.Qt.PenStyle",
        "Qt::PenStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "NoPen", (long) Qt::NoPen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "SolidLine", (long) Qt::SolidLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "DashLine", (long) Qt::DashLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "DotLine", (long) Qt::DotLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "DashDotLine", (long) Qt::DashDotLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "DashDotDotLine", (long) Qt::DashDotDotLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "CustomDashLine", (long) Qt::CustomDashLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX],
        &Sbk_Qt_Type, "MPenStyle", (long) Qt::MPenStyle))
        return ;
    // End of 'PenStyle' enum.

    // Initialization of enum 'ItemFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ITEMFLAG__IDX] = &SbkPySide_QtCore_Qt_ItemFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ItemFlag",
        "PySide.QtCore.Qt.ItemFlag",
        "Qt::ItemFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ITEMFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "NoItemFlags", (long) Qt::NoItemFlags))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsSelectable", (long) Qt::ItemIsSelectable))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsEditable", (long) Qt::ItemIsEditable))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsDragEnabled", (long) Qt::ItemIsDragEnabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsDropEnabled", (long) Qt::ItemIsDropEnabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsUserCheckable", (long) Qt::ItemIsUserCheckable))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsEnabled", (long) Qt::ItemIsEnabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX],
        &Sbk_Qt_Type, "ItemIsTristate", (long) Qt::ItemIsTristate))
        return ;
    // End of 'ItemFlag' enum.

    // Initialization of enum 'Axis'.
    SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "Axis",
        "PySide.QtCore.Qt.Axis",
        "Qt::Axis");
    if (!SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX],
        &Sbk_Qt_Type, "XAxis", (long) Qt::XAxis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX],
        &Sbk_Qt_Type, "YAxis", (long) Qt::YAxis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX],
        &Sbk_Qt_Type, "ZAxis", (long) Qt::ZAxis))
        return ;
    // End of 'Axis' enum.

    // Initialization of enum 'TransformationMode'.
    SbkPySide_QtCoreTypes[SBK_QT_TRANSFORMATIONMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TransformationMode",
        "PySide.QtCore.Qt.TransformationMode",
        "Qt::TransformationMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TRANSFORMATIONMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TRANSFORMATIONMODE_IDX],
        &Sbk_Qt_Type, "FastTransformation", (long) Qt::FastTransformation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TRANSFORMATIONMODE_IDX],
        &Sbk_Qt_Type, "SmoothTransformation", (long) Qt::SmoothTransformation))
        return ;
    // End of 'TransformationMode' enum.

    // Initialization of enum 'WindowFrameSection'.
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WindowFrameSection",
        "PySide.QtCore.Qt.WindowFrameSection",
        "Qt::WindowFrameSection");
    if (!SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "NoSection", (long) Qt::NoSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "LeftSection", (long) Qt::LeftSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "TopLeftSection", (long) Qt::TopLeftSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "TopSection", (long) Qt::TopSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "TopRightSection", (long) Qt::TopRightSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "RightSection", (long) Qt::RightSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "BottomRightSection", (long) Qt::BottomRightSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "BottomSection", (long) Qt::BottomSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "BottomLeftSection", (long) Qt::BottomLeftSection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX],
        &Sbk_Qt_Type, "TitleBarArea", (long) Qt::TitleBarArea))
        return ;
    // End of 'WindowFrameSection' enum.

    // Initialization of enum 'HitTestAccuracy'.
    SbkPySide_QtCoreTypes[SBK_QT_HITTESTACCURACY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "HitTestAccuracy",
        "PySide.QtCore.Qt.HitTestAccuracy",
        "Qt::HitTestAccuracy");
    if (!SbkPySide_QtCoreTypes[SBK_QT_HITTESTACCURACY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_HITTESTACCURACY_IDX],
        &Sbk_Qt_Type, "ExactHit", (long) Qt::ExactHit))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_HITTESTACCURACY_IDX],
        &Sbk_Qt_Type, "FuzzyHit", (long) Qt::FuzzyHit))
        return ;
    // End of 'HitTestAccuracy' enum.

    // Initialization of enum 'CursorShape'.
    SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "CursorShape",
        "PySide.QtCore.Qt.CursorShape",
        "Qt::CursorShape");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "ArrowCursor", (long) Qt::ArrowCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "UpArrowCursor", (long) Qt::UpArrowCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "CrossCursor", (long) Qt::CrossCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "WaitCursor", (long) Qt::WaitCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "IBeamCursor", (long) Qt::IBeamCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SizeVerCursor", (long) Qt::SizeVerCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SizeHorCursor", (long) Qt::SizeHorCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SizeBDiagCursor", (long) Qt::SizeBDiagCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SizeFDiagCursor", (long) Qt::SizeFDiagCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SizeAllCursor", (long) Qt::SizeAllCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "BlankCursor", (long) Qt::BlankCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SplitVCursor", (long) Qt::SplitVCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "SplitHCursor", (long) Qt::SplitHCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "PointingHandCursor", (long) Qt::PointingHandCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "ForbiddenCursor", (long) Qt::ForbiddenCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "WhatsThisCursor", (long) Qt::WhatsThisCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "BusyCursor", (long) Qt::BusyCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "OpenHandCursor", (long) Qt::OpenHandCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "ClosedHandCursor", (long) Qt::ClosedHandCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "DragCopyCursor", (long) Qt::DragCopyCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "DragMoveCursor", (long) Qt::DragMoveCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "DragLinkCursor", (long) Qt::DragLinkCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "LastCursor", (long) Qt::LastCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "BitmapCursor", (long) Qt::BitmapCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX],
        &Sbk_Qt_Type, "CustomCursor", (long) Qt::CustomCursor))
        return ;
    // End of 'CursorShape' enum.

    // Initialization of enum 'ItemSelectionMode'.
    SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ItemSelectionMode",
        "PySide.QtCore.Qt.ItemSelectionMode",
        "Qt::ItemSelectionMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX],
        &Sbk_Qt_Type, "ContainsItemShape", (long) Qt::ContainsItemShape))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX],
        &Sbk_Qt_Type, "IntersectsItemShape", (long) Qt::IntersectsItemShape))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX],
        &Sbk_Qt_Type, "ContainsItemBoundingRect", (long) Qt::ContainsItemBoundingRect))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX],
        &Sbk_Qt_Type, "IntersectsItemBoundingRect", (long) Qt::IntersectsItemBoundingRect))
        return ;
    // End of 'ItemSelectionMode' enum.

    // Initialization of enum 'Orientation'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ORIENTATION__IDX] = &SbkPySide_QtCore_Qt_Orientations_Type;
    SbkPySide_QtCoreTypes[SBK_QT_ORIENTATION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "Orientation",
        "PySide.QtCore.Qt.Orientation",
        "Qt::Orientation",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ORIENTATION__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_ORIENTATION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ORIENTATION_IDX],
        &Sbk_Qt_Type, "Horizontal", (long) Qt::Horizontal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ORIENTATION_IDX],
        &Sbk_Qt_Type, "Vertical", (long) Qt::Vertical))
        return ;
    // End of 'Orientation' enum.

    // Initialization of enum 'InputMethodQuery'.
    SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "InputMethodQuery",
        "PySide.QtCore.Qt.InputMethodQuery",
        "Qt::InputMethodQuery");
    if (!SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImMicroFocus", (long) Qt::ImMicroFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImFont", (long) Qt::ImFont))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImCursorPosition", (long) Qt::ImCursorPosition))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImSurroundingText", (long) Qt::ImSurroundingText))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImCurrentSelection", (long) Qt::ImCurrentSelection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImMaximumTextLength", (long) Qt::ImMaximumTextLength))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX],
        &Sbk_Qt_Type, "ImAnchorPosition", (long) Qt::ImAnchorPosition))
        return ;
    // End of 'InputMethodQuery' enum.

    // Initialization of enum 'TimeSpec'.
    SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TimeSpec",
        "PySide.QtCore.Qt.TimeSpec",
        "Qt::TimeSpec");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX],
        &Sbk_Qt_Type, "LocalTime", (long) Qt::LocalTime))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX],
        &Sbk_Qt_Type, "UTC", (long) Qt::UTC))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX],
        &Sbk_Qt_Type, "OffsetFromUTC", (long) Qt::OffsetFromUTC))
        return ;
    // End of 'TimeSpec' enum.

    // Initialization of enum 'ArrowType'.
    SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ArrowType",
        "PySide.QtCore.Qt.ArrowType",
        "Qt::ArrowType");
    if (!SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX],
        &Sbk_Qt_Type, "NoArrow", (long) Qt::NoArrow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX],
        &Sbk_Qt_Type, "UpArrow", (long) Qt::UpArrow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX],
        &Sbk_Qt_Type, "DownArrow", (long) Qt::DownArrow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX],
        &Sbk_Qt_Type, "LeftArrow", (long) Qt::LeftArrow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX],
        &Sbk_Qt_Type, "RightArrow", (long) Qt::RightArrow))
        return ;
    // End of 'ArrowType' enum.

    // Initialization of enum 'FillRule'.
    SbkPySide_QtCoreTypes[SBK_QT_FILLRULE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "FillRule",
        "PySide.QtCore.Qt.FillRule",
        "Qt::FillRule");
    if (!SbkPySide_QtCoreTypes[SBK_QT_FILLRULE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FILLRULE_IDX],
        &Sbk_Qt_Type, "OddEvenFill", (long) Qt::OddEvenFill))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_FILLRULE_IDX],
        &Sbk_Qt_Type, "WindingFill", (long) Qt::WindingFill))
        return ;
    // End of 'FillRule' enum.

    // Initialization of enum 'MaskMode'.
    SbkPySide_QtCoreTypes[SBK_QT_MASKMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "MaskMode",
        "PySide.QtCore.Qt.MaskMode",
        "Qt::MaskMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_MASKMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MASKMODE_IDX],
        &Sbk_Qt_Type, "MaskInColor", (long) Qt::MaskInColor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MASKMODE_IDX],
        &Sbk_Qt_Type, "MaskOutColor", (long) Qt::MaskOutColor))
        return ;
    // End of 'MaskMode' enum.

    // Initialization of enum 'WindowState'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWSTATE__IDX] = &SbkPySide_QtCore_Qt_WindowStates_Type;
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WindowState",
        "PySide.QtCore.Qt.WindowState",
        "Qt::WindowState",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWSTATE__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX],
        &Sbk_Qt_Type, "WindowNoState", (long) Qt::WindowNoState))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX],
        &Sbk_Qt_Type, "WindowMinimized", (long) Qt::WindowMinimized))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX],
        &Sbk_Qt_Type, "WindowMaximized", (long) Qt::WindowMaximized))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX],
        &Sbk_Qt_Type, "WindowFullScreen", (long) Qt::WindowFullScreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX],
        &Sbk_Qt_Type, "WindowActive", (long) Qt::WindowActive))
        return ;
    // End of 'WindowState' enum.

    // Initialization of enum 'ToolBarAreaSizes'.
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREASIZES_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ToolBarAreaSizes",
        "PySide.QtCore.Qt.ToolBarAreaSizes",
        "Qt::ToolBarAreaSizes");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREASIZES_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREASIZES_IDX],
        &Sbk_Qt_Type, "NToolBarAreas", (long) Qt::NToolBarAreas))
        return ;
    // End of 'ToolBarAreaSizes' enum.

    // Initialization of enum 'Corner'.
    SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "Corner",
        "PySide.QtCore.Qt.Corner",
        "Qt::Corner");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX],
        &Sbk_Qt_Type, "TopLeftCorner", (long) Qt::TopLeftCorner))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX],
        &Sbk_Qt_Type, "TopRightCorner", (long) Qt::TopRightCorner))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX],
        &Sbk_Qt_Type, "BottomLeftCorner", (long) Qt::BottomLeftCorner))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX],
        &Sbk_Qt_Type, "BottomRightCorner", (long) Qt::BottomRightCorner))
        return ;
    // End of 'Corner' enum.

    // Initialization of enum 'DayOfWeek'.
    SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "DayOfWeek",
        "PySide.QtCore.Qt.DayOfWeek",
        "Qt::DayOfWeek");
    if (!SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Monday", (long) Qt::Monday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Tuesday", (long) Qt::Tuesday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Wednesday", (long) Qt::Wednesday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Thursday", (long) Qt::Thursday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Friday", (long) Qt::Friday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Saturday", (long) Qt::Saturday))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX],
        &Sbk_Qt_Type, "Sunday", (long) Qt::Sunday))
        return ;
    // End of 'DayOfWeek' enum.

    // Initialization of enum 'ClipOperation'.
    SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ClipOperation",
        "PySide.QtCore.Qt.ClipOperation",
        "Qt::ClipOperation");
    if (!SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX],
        &Sbk_Qt_Type, "NoClip", (long) Qt::NoClip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX],
        &Sbk_Qt_Type, "ReplaceClip", (long) Qt::ReplaceClip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX],
        &Sbk_Qt_Type, "IntersectClip", (long) Qt::IntersectClip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX],
        &Sbk_Qt_Type, "UniteClip", (long) Qt::UniteClip))
        return ;
    // End of 'ClipOperation' enum.

    // Initialization of enum 'LayoutDirection'.
    SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "LayoutDirection",
        "PySide.QtCore.Qt.LayoutDirection",
        "Qt::LayoutDirection");
    if (!SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX],
        &Sbk_Qt_Type, "LeftToRight", (long) Qt::LeftToRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX],
        &Sbk_Qt_Type, "RightToLeft", (long) Qt::RightToLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX],
        &Sbk_Qt_Type, "LayoutDirectionAuto", (long) Qt::LayoutDirectionAuto))
        return ;
    // End of 'LayoutDirection' enum.

    // Initialization of enum 'ToolButtonStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ToolButtonStyle",
        "PySide.QtCore.Qt.ToolButtonStyle",
        "Qt::ToolButtonStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX],
        &Sbk_Qt_Type, "ToolButtonIconOnly", (long) Qt::ToolButtonIconOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX],
        &Sbk_Qt_Type, "ToolButtonTextOnly", (long) Qt::ToolButtonTextOnly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX],
        &Sbk_Qt_Type, "ToolButtonTextBesideIcon", (long) Qt::ToolButtonTextBesideIcon))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX],
        &Sbk_Qt_Type, "ToolButtonTextUnderIcon", (long) Qt::ToolButtonTextUnderIcon))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX],
        &Sbk_Qt_Type, "ToolButtonFollowStyle", (long) Qt::ToolButtonFollowStyle))
        return ;
    // End of 'ToolButtonStyle' enum.

    // Initialization of enum 'DockWidgetAreaSizes'.
    SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREASIZES_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "DockWidgetAreaSizes",
        "PySide.QtCore.Qt.DockWidgetAreaSizes",
        "Qt::DockWidgetAreaSizes");
    if (!SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREASIZES_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREASIZES_IDX],
        &Sbk_Qt_Type, "NDockWidgetAreas", (long) Qt::NDockWidgetAreas))
        return ;
    // End of 'DockWidgetAreaSizes' enum.

    // Initialization of enum 'Key'.
    SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "Key",
        "PySide.QtCore.Qt.Key",
        "Qt::Key");
    if (!SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Escape", (long) Qt::Key_Escape))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Tab", (long) Qt::Key_Tab))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Backtab", (long) Qt::Key_Backtab))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Backspace", (long) Qt::Key_Backspace))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Return", (long) Qt::Key_Return))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Enter", (long) Qt::Key_Enter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Insert", (long) Qt::Key_Insert))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Delete", (long) Qt::Key_Delete))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Pause", (long) Qt::Key_Pause))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Print", (long) Qt::Key_Print))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_SysReq", (long) Qt::Key_SysReq))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Clear", (long) Qt::Key_Clear))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Home", (long) Qt::Key_Home))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_End", (long) Qt::Key_End))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Left", (long) Qt::Key_Left))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Up", (long) Qt::Key_Up))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Right", (long) Qt::Key_Right))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Down", (long) Qt::Key_Down))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_PageUp", (long) Qt::Key_PageUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_PageDown", (long) Qt::Key_PageDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Shift", (long) Qt::Key_Shift))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Control", (long) Qt::Key_Control))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Meta", (long) Qt::Key_Meta))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Alt", (long) Qt::Key_Alt))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_CapsLock", (long) Qt::Key_CapsLock))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_NumLock", (long) Qt::Key_NumLock))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ScrollLock", (long) Qt::Key_ScrollLock))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F1", (long) Qt::Key_F1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F2", (long) Qt::Key_F2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F3", (long) Qt::Key_F3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F4", (long) Qt::Key_F4))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F5", (long) Qt::Key_F5))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F6", (long) Qt::Key_F6))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F7", (long) Qt::Key_F7))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F8", (long) Qt::Key_F8))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F9", (long) Qt::Key_F9))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F10", (long) Qt::Key_F10))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F11", (long) Qt::Key_F11))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F12", (long) Qt::Key_F12))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F13", (long) Qt::Key_F13))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F14", (long) Qt::Key_F14))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F15", (long) Qt::Key_F15))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F16", (long) Qt::Key_F16))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F17", (long) Qt::Key_F17))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F18", (long) Qt::Key_F18))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F19", (long) Qt::Key_F19))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F20", (long) Qt::Key_F20))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F21", (long) Qt::Key_F21))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F22", (long) Qt::Key_F22))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F23", (long) Qt::Key_F23))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F24", (long) Qt::Key_F24))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F25", (long) Qt::Key_F25))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F26", (long) Qt::Key_F26))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F27", (long) Qt::Key_F27))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F28", (long) Qt::Key_F28))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F29", (long) Qt::Key_F29))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F30", (long) Qt::Key_F30))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F31", (long) Qt::Key_F31))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F32", (long) Qt::Key_F32))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F33", (long) Qt::Key_F33))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F34", (long) Qt::Key_F34))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F35", (long) Qt::Key_F35))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Super_L", (long) Qt::Key_Super_L))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Super_R", (long) Qt::Key_Super_R))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Menu", (long) Qt::Key_Menu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hyper_L", (long) Qt::Key_Hyper_L))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hyper_R", (long) Qt::Key_Hyper_R))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Help", (long) Qt::Key_Help))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Direction_L", (long) Qt::Key_Direction_L))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Direction_R", (long) Qt::Key_Direction_R))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Space", (long) Qt::Key_Space))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Any", (long) Qt::Key_Any))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Exclam", (long) Qt::Key_Exclam))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_QuoteDbl", (long) Qt::Key_QuoteDbl))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_NumberSign", (long) Qt::Key_NumberSign))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dollar", (long) Qt::Key_Dollar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Percent", (long) Qt::Key_Percent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ampersand", (long) Qt::Key_Ampersand))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Apostrophe", (long) Qt::Key_Apostrophe))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ParenLeft", (long) Qt::Key_ParenLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ParenRight", (long) Qt::Key_ParenRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Asterisk", (long) Qt::Key_Asterisk))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Plus", (long) Qt::Key_Plus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Comma", (long) Qt::Key_Comma))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Minus", (long) Qt::Key_Minus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Period", (long) Qt::Key_Period))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Slash", (long) Qt::Key_Slash))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_0", (long) Qt::Key_0))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_1", (long) Qt::Key_1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_2", (long) Qt::Key_2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_3", (long) Qt::Key_3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_4", (long) Qt::Key_4))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_5", (long) Qt::Key_5))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_6", (long) Qt::Key_6))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_7", (long) Qt::Key_7))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_8", (long) Qt::Key_8))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_9", (long) Qt::Key_9))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Colon", (long) Qt::Key_Colon))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Semicolon", (long) Qt::Key_Semicolon))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Less", (long) Qt::Key_Less))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Equal", (long) Qt::Key_Equal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Greater", (long) Qt::Key_Greater))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Question", (long) Qt::Key_Question))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_At", (long) Qt::Key_At))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_A", (long) Qt::Key_A))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_B", (long) Qt::Key_B))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_C", (long) Qt::Key_C))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_D", (long) Qt::Key_D))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_E", (long) Qt::Key_E))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_F", (long) Qt::Key_F))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_G", (long) Qt::Key_G))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_H", (long) Qt::Key_H))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_I", (long) Qt::Key_I))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_J", (long) Qt::Key_J))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_K", (long) Qt::Key_K))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_L", (long) Qt::Key_L))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_M", (long) Qt::Key_M))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_N", (long) Qt::Key_N))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_O", (long) Qt::Key_O))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_P", (long) Qt::Key_P))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Q", (long) Qt::Key_Q))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_R", (long) Qt::Key_R))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_S", (long) Qt::Key_S))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_T", (long) Qt::Key_T))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_U", (long) Qt::Key_U))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_V", (long) Qt::Key_V))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_W", (long) Qt::Key_W))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_X", (long) Qt::Key_X))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Y", (long) Qt::Key_Y))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Z", (long) Qt::Key_Z))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BracketLeft", (long) Qt::Key_BracketLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Backslash", (long) Qt::Key_Backslash))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BracketRight", (long) Qt::Key_BracketRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AsciiCircum", (long) Qt::Key_AsciiCircum))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Underscore", (long) Qt::Key_Underscore))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_QuoteLeft", (long) Qt::Key_QuoteLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BraceLeft", (long) Qt::Key_BraceLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Bar", (long) Qt::Key_Bar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BraceRight", (long) Qt::Key_BraceRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AsciiTilde", (long) Qt::Key_AsciiTilde))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_nobreakspace", (long) Qt::Key_nobreakspace))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_exclamdown", (long) Qt::Key_exclamdown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_cent", (long) Qt::Key_cent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_sterling", (long) Qt::Key_sterling))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_currency", (long) Qt::Key_currency))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_yen", (long) Qt::Key_yen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_brokenbar", (long) Qt::Key_brokenbar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_section", (long) Qt::Key_section))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_diaeresis", (long) Qt::Key_diaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_copyright", (long) Qt::Key_copyright))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ordfeminine", (long) Qt::Key_ordfeminine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_guillemotleft", (long) Qt::Key_guillemotleft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_notsign", (long) Qt::Key_notsign))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_hyphen", (long) Qt::Key_hyphen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_registered", (long) Qt::Key_registered))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_macron", (long) Qt::Key_macron))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_degree", (long) Qt::Key_degree))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_plusminus", (long) Qt::Key_plusminus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_twosuperior", (long) Qt::Key_twosuperior))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_threesuperior", (long) Qt::Key_threesuperior))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_acute", (long) Qt::Key_acute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_mu", (long) Qt::Key_mu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_paragraph", (long) Qt::Key_paragraph))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_periodcentered", (long) Qt::Key_periodcentered))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_cedilla", (long) Qt::Key_cedilla))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_onesuperior", (long) Qt::Key_onesuperior))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_masculine", (long) Qt::Key_masculine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_guillemotright", (long) Qt::Key_guillemotright))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_onequarter", (long) Qt::Key_onequarter))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_onehalf", (long) Qt::Key_onehalf))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_threequarters", (long) Qt::Key_threequarters))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_questiondown", (long) Qt::Key_questiondown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Agrave", (long) Qt::Key_Agrave))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Aacute", (long) Qt::Key_Aacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Acircumflex", (long) Qt::Key_Acircumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Atilde", (long) Qt::Key_Atilde))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Adiaeresis", (long) Qt::Key_Adiaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Aring", (long) Qt::Key_Aring))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AE", (long) Qt::Key_AE))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ccedilla", (long) Qt::Key_Ccedilla))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Egrave", (long) Qt::Key_Egrave))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Eacute", (long) Qt::Key_Eacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ecircumflex", (long) Qt::Key_Ecircumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ediaeresis", (long) Qt::Key_Ediaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Igrave", (long) Qt::Key_Igrave))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Iacute", (long) Qt::Key_Iacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Icircumflex", (long) Qt::Key_Icircumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Idiaeresis", (long) Qt::Key_Idiaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ETH", (long) Qt::Key_ETH))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ntilde", (long) Qt::Key_Ntilde))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ograve", (long) Qt::Key_Ograve))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Oacute", (long) Qt::Key_Oacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ocircumflex", (long) Qt::Key_Ocircumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Otilde", (long) Qt::Key_Otilde))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Odiaeresis", (long) Qt::Key_Odiaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_multiply", (long) Qt::Key_multiply))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ooblique", (long) Qt::Key_Ooblique))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ugrave", (long) Qt::Key_Ugrave))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Uacute", (long) Qt::Key_Uacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Ucircumflex", (long) Qt::Key_Ucircumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Udiaeresis", (long) Qt::Key_Udiaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Yacute", (long) Qt::Key_Yacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_THORN", (long) Qt::Key_THORN))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ssharp", (long) Qt::Key_ssharp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_division", (long) Qt::Key_division))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ydiaeresis", (long) Qt::Key_ydiaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AltGr", (long) Qt::Key_AltGr))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Multi_key", (long) Qt::Key_Multi_key))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Codeinput", (long) Qt::Key_Codeinput))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_SingleCandidate", (long) Qt::Key_SingleCandidate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MultipleCandidate", (long) Qt::Key_MultipleCandidate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_PreviousCandidate", (long) Qt::Key_PreviousCandidate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Mode_switch", (long) Qt::Key_Mode_switch))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Kanji", (long) Qt::Key_Kanji))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Muhenkan", (long) Qt::Key_Muhenkan))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Henkan", (long) Qt::Key_Henkan))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Romaji", (long) Qt::Key_Romaji))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hiragana", (long) Qt::Key_Hiragana))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Katakana", (long) Qt::Key_Katakana))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hiragana_Katakana", (long) Qt::Key_Hiragana_Katakana))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Zenkaku", (long) Qt::Key_Zenkaku))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hankaku", (long) Qt::Key_Hankaku))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Zenkaku_Hankaku", (long) Qt::Key_Zenkaku_Hankaku))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Touroku", (long) Qt::Key_Touroku))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Massyo", (long) Qt::Key_Massyo))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Kana_Lock", (long) Qt::Key_Kana_Lock))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Kana_Shift", (long) Qt::Key_Kana_Shift))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Eisu_Shift", (long) Qt::Key_Eisu_Shift))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Eisu_toggle", (long) Qt::Key_Eisu_toggle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul", (long) Qt::Key_Hangul))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Start", (long) Qt::Key_Hangul_Start))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_End", (long) Qt::Key_Hangul_End))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Hanja", (long) Qt::Key_Hangul_Hanja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Jamo", (long) Qt::Key_Hangul_Jamo))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Romaja", (long) Qt::Key_Hangul_Romaja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Jeonja", (long) Qt::Key_Hangul_Jeonja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Banja", (long) Qt::Key_Hangul_Banja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_PreHanja", (long) Qt::Key_Hangul_PreHanja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_PostHanja", (long) Qt::Key_Hangul_PostHanja))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangul_Special", (long) Qt::Key_Hangul_Special))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Grave", (long) Qt::Key_Dead_Grave))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Acute", (long) Qt::Key_Dead_Acute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Circumflex", (long) Qt::Key_Dead_Circumflex))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Tilde", (long) Qt::Key_Dead_Tilde))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Macron", (long) Qt::Key_Dead_Macron))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Breve", (long) Qt::Key_Dead_Breve))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Abovedot", (long) Qt::Key_Dead_Abovedot))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Diaeresis", (long) Qt::Key_Dead_Diaeresis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Abovering", (long) Qt::Key_Dead_Abovering))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Doubleacute", (long) Qt::Key_Dead_Doubleacute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Caron", (long) Qt::Key_Dead_Caron))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Cedilla", (long) Qt::Key_Dead_Cedilla))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Ogonek", (long) Qt::Key_Dead_Ogonek))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Iota", (long) Qt::Key_Dead_Iota))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Voiced_Sound", (long) Qt::Key_Dead_Voiced_Sound))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Semivoiced_Sound", (long) Qt::Key_Dead_Semivoiced_Sound))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Belowdot", (long) Qt::Key_Dead_Belowdot))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Hook", (long) Qt::Key_Dead_Hook))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Dead_Horn", (long) Qt::Key_Dead_Horn))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Back", (long) Qt::Key_Back))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Forward", (long) Qt::Key_Forward))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Stop", (long) Qt::Key_Stop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Refresh", (long) Qt::Key_Refresh))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_VolumeDown", (long) Qt::Key_VolumeDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_VolumeMute", (long) Qt::Key_VolumeMute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_VolumeUp", (long) Qt::Key_VolumeUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BassBoost", (long) Qt::Key_BassBoost))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BassUp", (long) Qt::Key_BassUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BassDown", (long) Qt::Key_BassDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_TrebleUp", (long) Qt::Key_TrebleUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_TrebleDown", (long) Qt::Key_TrebleDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaPlay", (long) Qt::Key_MediaPlay))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaStop", (long) Qt::Key_MediaStop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaPrevious", (long) Qt::Key_MediaPrevious))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaNext", (long) Qt::Key_MediaNext))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaRecord", (long) Qt::Key_MediaRecord))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaPause", (long) Qt::Key_MediaPause))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaTogglePlayPause", (long) Qt::Key_MediaTogglePlayPause))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_HomePage", (long) Qt::Key_HomePage))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Favorites", (long) Qt::Key_Favorites))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Search", (long) Qt::Key_Search))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Standby", (long) Qt::Key_Standby))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_OpenUrl", (long) Qt::Key_OpenUrl))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchMail", (long) Qt::Key_LaunchMail))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchMedia", (long) Qt::Key_LaunchMedia))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch0", (long) Qt::Key_Launch0))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch1", (long) Qt::Key_Launch1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch2", (long) Qt::Key_Launch2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch3", (long) Qt::Key_Launch3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch4", (long) Qt::Key_Launch4))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch5", (long) Qt::Key_Launch5))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch6", (long) Qt::Key_Launch6))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch7", (long) Qt::Key_Launch7))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch8", (long) Qt::Key_Launch8))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Launch9", (long) Qt::Key_Launch9))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchA", (long) Qt::Key_LaunchA))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchB", (long) Qt::Key_LaunchB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchC", (long) Qt::Key_LaunchC))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchD", (long) Qt::Key_LaunchD))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchE", (long) Qt::Key_LaunchE))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchF", (long) Qt::Key_LaunchF))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MonBrightnessUp", (long) Qt::Key_MonBrightnessUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MonBrightnessDown", (long) Qt::Key_MonBrightnessDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_KeyboardLightOnOff", (long) Qt::Key_KeyboardLightOnOff))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_KeyboardBrightnessUp", (long) Qt::Key_KeyboardBrightnessUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_KeyboardBrightnessDown", (long) Qt::Key_KeyboardBrightnessDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_PowerOff", (long) Qt::Key_PowerOff))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_WakeUp", (long) Qt::Key_WakeUp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Eject", (long) Qt::Key_Eject))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ScreenSaver", (long) Qt::Key_ScreenSaver))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_WWW", (long) Qt::Key_WWW))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Memo", (long) Qt::Key_Memo))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LightBulb", (long) Qt::Key_LightBulb))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Shop", (long) Qt::Key_Shop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_History", (long) Qt::Key_History))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AddFavorite", (long) Qt::Key_AddFavorite))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_HotLinks", (long) Qt::Key_HotLinks))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BrightnessAdjust", (long) Qt::Key_BrightnessAdjust))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Finance", (long) Qt::Key_Finance))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Community", (long) Qt::Key_Community))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AudioRewind", (long) Qt::Key_AudioRewind))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_BackForward", (long) Qt::Key_BackForward))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ApplicationLeft", (long) Qt::Key_ApplicationLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ApplicationRight", (long) Qt::Key_ApplicationRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Book", (long) Qt::Key_Book))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_CD", (long) Qt::Key_CD))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Calculator", (long) Qt::Key_Calculator))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ToDoList", (long) Qt::Key_ToDoList))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ClearGrab", (long) Qt::Key_ClearGrab))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Close", (long) Qt::Key_Close))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Copy", (long) Qt::Key_Copy))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Cut", (long) Qt::Key_Cut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Display", (long) Qt::Key_Display))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_DOS", (long) Qt::Key_DOS))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Documents", (long) Qt::Key_Documents))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Excel", (long) Qt::Key_Excel))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Explorer", (long) Qt::Key_Explorer))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Game", (long) Qt::Key_Game))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Go", (long) Qt::Key_Go))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_iTouch", (long) Qt::Key_iTouch))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LogOff", (long) Qt::Key_LogOff))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Market", (long) Qt::Key_Market))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Meeting", (long) Qt::Key_Meeting))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MenuKB", (long) Qt::Key_MenuKB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MenuPB", (long) Qt::Key_MenuPB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MySites", (long) Qt::Key_MySites))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_News", (long) Qt::Key_News))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_OfficeHome", (long) Qt::Key_OfficeHome))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Option", (long) Qt::Key_Option))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Paste", (long) Qt::Key_Paste))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Phone", (long) Qt::Key_Phone))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Calendar", (long) Qt::Key_Calendar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Reply", (long) Qt::Key_Reply))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Reload", (long) Qt::Key_Reload))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_RotateWindows", (long) Qt::Key_RotateWindows))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_RotationPB", (long) Qt::Key_RotationPB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_RotationKB", (long) Qt::Key_RotationKB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Save", (long) Qt::Key_Save))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Send", (long) Qt::Key_Send))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Spell", (long) Qt::Key_Spell))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_SplitScreen", (long) Qt::Key_SplitScreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Support", (long) Qt::Key_Support))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_TaskPane", (long) Qt::Key_TaskPane))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Terminal", (long) Qt::Key_Terminal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Tools", (long) Qt::Key_Tools))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Travel", (long) Qt::Key_Travel))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Video", (long) Qt::Key_Video))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Word", (long) Qt::Key_Word))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Xfer", (long) Qt::Key_Xfer))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ZoomIn", (long) Qt::Key_ZoomIn))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ZoomOut", (long) Qt::Key_ZoomOut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Away", (long) Qt::Key_Away))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Messenger", (long) Qt::Key_Messenger))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_WebCam", (long) Qt::Key_WebCam))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MailForward", (long) Qt::Key_MailForward))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Pictures", (long) Qt::Key_Pictures))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Music", (long) Qt::Key_Music))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Battery", (long) Qt::Key_Battery))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Bluetooth", (long) Qt::Key_Bluetooth))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_WLAN", (long) Qt::Key_WLAN))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_UWB", (long) Qt::Key_UWB))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AudioForward", (long) Qt::Key_AudioForward))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AudioRepeat", (long) Qt::Key_AudioRepeat))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AudioRandomPlay", (long) Qt::Key_AudioRandomPlay))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Subtitle", (long) Qt::Key_Subtitle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_AudioCycleTrack", (long) Qt::Key_AudioCycleTrack))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Time", (long) Qt::Key_Time))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hibernate", (long) Qt::Key_Hibernate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_View", (long) Qt::Key_View))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_TopMenu", (long) Qt::Key_TopMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_PowerDown", (long) Qt::Key_PowerDown))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Suspend", (long) Qt::Key_Suspend))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ContrastAdjust", (long) Qt::Key_ContrastAdjust))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchG", (long) Qt::Key_LaunchG))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LaunchH", (long) Qt::Key_LaunchH))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_MediaLast", (long) Qt::Key_MediaLast))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Select", (long) Qt::Key_Select))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Yes", (long) Qt::Key_Yes))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_No", (long) Qt::Key_No))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Cancel", (long) Qt::Key_Cancel))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Printer", (long) Qt::Key_Printer))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Execute", (long) Qt::Key_Execute))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Sleep", (long) Qt::Key_Sleep))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Play", (long) Qt::Key_Play))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Zoom", (long) Qt::Key_Zoom))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Context1", (long) Qt::Key_Context1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Context2", (long) Qt::Key_Context2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Context3", (long) Qt::Key_Context3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Context4", (long) Qt::Key_Context4))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Call", (long) Qt::Key_Call))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Hangup", (long) Qt::Key_Hangup))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Flip", (long) Qt::Key_Flip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_ToggleCallHangup", (long) Qt::Key_ToggleCallHangup))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_VoiceDial", (long) Qt::Key_VoiceDial))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_LastNumberRedial", (long) Qt::Key_LastNumberRedial))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_Camera", (long) Qt::Key_Camera))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_CameraFocus", (long) Qt::Key_CameraFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX],
        &Sbk_Qt_Type, "Key_unknown", (long) Qt::Key_unknown))
        return ;
    // End of 'Key' enum.

    // Initialization of enum 'ApplicationAttribute'.
    SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "ApplicationAttribute",
        "PySide.QtCore.Qt.ApplicationAttribute",
        "Qt::ApplicationAttribute");
    if (!SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_ImmediateWidgetCreation", (long) Qt::AA_ImmediateWidgetCreation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_MSWindowsUseDirect3DByDefault", (long) Qt::AA_MSWindowsUseDirect3DByDefault))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_DontShowIconsInMenus", (long) Qt::AA_DontShowIconsInMenus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_NativeWindows", (long) Qt::AA_NativeWindows))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_DontCreateNativeWidgetSiblings", (long) Qt::AA_DontCreateNativeWidgetSiblings))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_MacPluginApplication", (long) Qt::AA_MacPluginApplication))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_DontUseNativeMenuBar", (long) Qt::AA_DontUseNativeMenuBar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_MacDontSwapCtrlAndMeta", (long) Qt::AA_MacDontSwapCtrlAndMeta))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_S60DontConstructApplicationPanes", (long) Qt::AA_S60DontConstructApplicationPanes))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_S60DisablePartialScreenInputMode", (long) Qt::AA_S60DisablePartialScreenInputMode))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_X11InitThreads", (long) Qt::AA_X11InitThreads))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_CaptureMultimediaKeys", (long) Qt::AA_CaptureMultimediaKeys))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX],
        &Sbk_Qt_Type, "AA_AttributeCount", (long) Qt::AA_AttributeCount))
        return ;
    // End of 'ApplicationAttribute' enum.

    // Initialization of enum 'TextFlag'.
    SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TextFlag",
        "PySide.QtCore.Qt.TextFlag",
        "Qt::TextFlag");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextSingleLine", (long) Qt::TextSingleLine))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextDontClip", (long) Qt::TextDontClip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextExpandTabs", (long) Qt::TextExpandTabs))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextShowMnemonic", (long) Qt::TextShowMnemonic))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextWordWrap", (long) Qt::TextWordWrap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextWrapAnywhere", (long) Qt::TextWrapAnywhere))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextDontPrint", (long) Qt::TextDontPrint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextIncludeTrailingSpaces", (long) Qt::TextIncludeTrailingSpaces))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextHideMnemonic", (long) Qt::TextHideMnemonic))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextJustificationForced", (long) Qt::TextJustificationForced))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextForceLeftToRight", (long) Qt::TextForceLeftToRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextForceRightToLeft", (long) Qt::TextForceRightToLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextLongestVariant", (long) Qt::TextLongestVariant))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX],
        &Sbk_Qt_Type, "TextBypassShaping", (long) Qt::TextBypassShaping))
        return ;
    // End of 'TextFlag' enum.

    // Initialization of enum 'BrushStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "BrushStyle",
        "PySide.QtCore.Qt.BrushStyle",
        "Qt::BrushStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "NoBrush", (long) Qt::NoBrush))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "SolidPattern", (long) Qt::SolidPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense1Pattern", (long) Qt::Dense1Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense2Pattern", (long) Qt::Dense2Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense3Pattern", (long) Qt::Dense3Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense4Pattern", (long) Qt::Dense4Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense5Pattern", (long) Qt::Dense5Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense6Pattern", (long) Qt::Dense6Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "Dense7Pattern", (long) Qt::Dense7Pattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "HorPattern", (long) Qt::HorPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "VerPattern", (long) Qt::VerPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "CrossPattern", (long) Qt::CrossPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "BDiagPattern", (long) Qt::BDiagPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "FDiagPattern", (long) Qt::FDiagPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "DiagCrossPattern", (long) Qt::DiagCrossPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "LinearGradientPattern", (long) Qt::LinearGradientPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "RadialGradientPattern", (long) Qt::RadialGradientPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "ConicalGradientPattern", (long) Qt::ConicalGradientPattern))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX],
        &Sbk_Qt_Type, "TexturePattern", (long) Qt::TexturePattern))
        return ;
    // End of 'BrushStyle' enum.

    // Initialization of enum 'WidgetAttribute'.
    SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "WidgetAttribute",
        "PySide.QtCore.Qt.WidgetAttribute",
        "Qt::WidgetAttribute");
    if (!SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_Disabled", (long) Qt::WA_Disabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_UnderMouse", (long) Qt::WA_UnderMouse))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MouseTracking", (long) Qt::WA_MouseTracking))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ContentsPropagated", (long) Qt::WA_ContentsPropagated))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_OpaquePaintEvent", (long) Qt::WA_OpaquePaintEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoBackground", (long) Qt::WA_NoBackground))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_StaticContents", (long) Qt::WA_StaticContents))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_LaidOut", (long) Qt::WA_LaidOut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PaintOnScreen", (long) Qt::WA_PaintOnScreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoSystemBackground", (long) Qt::WA_NoSystemBackground))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_UpdatesDisabled", (long) Qt::WA_UpdatesDisabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_Mapped", (long) Qt::WA_Mapped))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacNoClickThrough", (long) Qt::WA_MacNoClickThrough))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PaintOutsidePaintEvent", (long) Qt::WA_PaintOutsidePaintEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_InputMethodEnabled", (long) Qt::WA_InputMethodEnabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_Visible", (long) Qt::WA_WState_Visible))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_Hidden", (long) Qt::WA_WState_Hidden))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ForceDisabled", (long) Qt::WA_ForceDisabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_KeyCompression", (long) Qt::WA_KeyCompression))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PendingMoveEvent", (long) Qt::WA_PendingMoveEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PendingResizeEvent", (long) Qt::WA_PendingResizeEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetPalette", (long) Qt::WA_SetPalette))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetFont", (long) Qt::WA_SetFont))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetCursor", (long) Qt::WA_SetCursor))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoChildEventsFromChildren", (long) Qt::WA_NoChildEventsFromChildren))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WindowModified", (long) Qt::WA_WindowModified))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_Resized", (long) Qt::WA_Resized))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_Moved", (long) Qt::WA_Moved))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PendingUpdate", (long) Qt::WA_PendingUpdate))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_InvalidSize", (long) Qt::WA_InvalidSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacBrushedMetal", (long) Qt::WA_MacBrushedMetal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacMetalStyle", (long) Qt::WA_MacMetalStyle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_CustomWhatsThis", (long) Qt::WA_CustomWhatsThis))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_LayoutOnEntireRect", (long) Qt::WA_LayoutOnEntireRect))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_OutsideWSRange", (long) Qt::WA_OutsideWSRange))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_GrabbedShortcut", (long) Qt::WA_GrabbedShortcut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_TransparentForMouseEvents", (long) Qt::WA_TransparentForMouseEvents))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_PaintUnclipped", (long) Qt::WA_PaintUnclipped))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetWindowIcon", (long) Qt::WA_SetWindowIcon))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoMouseReplay", (long) Qt::WA_NoMouseReplay))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_DeleteOnClose", (long) Qt::WA_DeleteOnClose))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_RightToLeft", (long) Qt::WA_RightToLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetLayoutDirection", (long) Qt::WA_SetLayoutDirection))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoChildEventsForParent", (long) Qt::WA_NoChildEventsForParent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ForceUpdatesDisabled", (long) Qt::WA_ForceUpdatesDisabled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_Created", (long) Qt::WA_WState_Created))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_CompressKeys", (long) Qt::WA_WState_CompressKeys))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_InPaintEvent", (long) Qt::WA_WState_InPaintEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_Reparented", (long) Qt::WA_WState_Reparented))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_ConfigPending", (long) Qt::WA_WState_ConfigPending))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_Polished", (long) Qt::WA_WState_Polished))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_DND", (long) Qt::WA_WState_DND))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_OwnSizePolicy", (long) Qt::WA_WState_OwnSizePolicy))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_ExplicitShowHide", (long) Qt::WA_WState_ExplicitShowHide))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ShowModal", (long) Qt::WA_ShowModal))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MouseNoMask", (long) Qt::WA_MouseNoMask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_GroupLeader", (long) Qt::WA_GroupLeader))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoMousePropagation", (long) Qt::WA_NoMousePropagation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_Hover", (long) Qt::WA_Hover))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_InputMethodTransparent", (long) Qt::WA_InputMethodTransparent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_QuitOnClose", (long) Qt::WA_QuitOnClose))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_KeyboardFocusChange", (long) Qt::WA_KeyboardFocusChange))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_AcceptDrops", (long) Qt::WA_AcceptDrops))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_DropSiteRegistered", (long) Qt::WA_DropSiteRegistered))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ForceAcceptDrops", (long) Qt::WA_ForceAcceptDrops))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WindowPropagation", (long) Qt::WA_WindowPropagation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NoX11EventCompression", (long) Qt::WA_NoX11EventCompression))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_TintedBackground", (long) Qt::WA_TintedBackground))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11OpenGLOverlay", (long) Qt::WA_X11OpenGLOverlay))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_AlwaysShowToolTips", (long) Qt::WA_AlwaysShowToolTips))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacOpaqueSizeGrip", (long) Qt::WA_MacOpaqueSizeGrip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetStyle", (long) Qt::WA_SetStyle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetLocale", (long) Qt::WA_SetLocale))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacShowFocusRect", (long) Qt::WA_MacShowFocusRect))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacNormalSize", (long) Qt::WA_MacNormalSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacSmallSize", (long) Qt::WA_MacSmallSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacMiniSize", (long) Qt::WA_MacMiniSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_LayoutUsesWidgetRect", (long) Qt::WA_LayoutUsesWidgetRect))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_StyledBackground", (long) Qt::WA_StyledBackground))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MSWindowsUseDirect3D", (long) Qt::WA_MSWindowsUseDirect3D))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_CanHostQMdiSubWindowTitleBar", (long) Qt::WA_CanHostQMdiSubWindowTitleBar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacAlwaysShowToolWindow", (long) Qt::WA_MacAlwaysShowToolWindow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_StyleSheet", (long) Qt::WA_StyleSheet))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_ShowWithoutActivating", (long) Qt::WA_ShowWithoutActivating))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11BypassTransientForHint", (long) Qt::WA_X11BypassTransientForHint))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_NativeWindow", (long) Qt::WA_NativeWindow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_DontCreateNativeAncestors", (long) Qt::WA_DontCreateNativeAncestors))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacVariableSize", (long) Qt::WA_MacVariableSize))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_DontShowOnScreen", (long) Qt::WA_DontShowOnScreen))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeDesktop", (long) Qt::WA_X11NetWmWindowTypeDesktop))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeDock", (long) Qt::WA_X11NetWmWindowTypeDock))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeToolBar", (long) Qt::WA_X11NetWmWindowTypeToolBar))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeMenu", (long) Qt::WA_X11NetWmWindowTypeMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeUtility", (long) Qt::WA_X11NetWmWindowTypeUtility))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeSplash", (long) Qt::WA_X11NetWmWindowTypeSplash))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeDialog", (long) Qt::WA_X11NetWmWindowTypeDialog))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeDropDownMenu", (long) Qt::WA_X11NetWmWindowTypeDropDownMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypePopupMenu", (long) Qt::WA_X11NetWmWindowTypePopupMenu))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeToolTip", (long) Qt::WA_X11NetWmWindowTypeToolTip))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeNotification", (long) Qt::WA_X11NetWmWindowTypeNotification))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeCombo", (long) Qt::WA_X11NetWmWindowTypeCombo))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11NetWmWindowTypeDND", (long) Qt::WA_X11NetWmWindowTypeDND))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacFrameworkScaled", (long) Qt::WA_MacFrameworkScaled))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SetWindowModality", (long) Qt::WA_SetWindowModality))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_WindowOpacitySet", (long) Qt::WA_WState_WindowOpacitySet))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_TranslucentBackground", (long) Qt::WA_TranslucentBackground))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_AcceptTouchEvents", (long) Qt::WA_AcceptTouchEvents))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_WState_AcceptedTouchBeginEvent", (long) Qt::WA_WState_AcceptedTouchBeginEvent))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_TouchPadAcceptSingleTouchEvents", (long) Qt::WA_TouchPadAcceptSingleTouchEvents))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MergeSoftkeys", (long) Qt::WA_MergeSoftkeys))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MergeSoftkeysRecursively", (long) Qt::WA_MergeSoftkeysRecursively))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_LockPortraitOrientation", (long) Qt::WA_LockPortraitOrientation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_LockLandscapeOrientation", (long) Qt::WA_LockLandscapeOrientation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_AutoOrientation", (long) Qt::WA_AutoOrientation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_X11DoNotAcceptFocus", (long) Qt::WA_X11DoNotAcceptFocus))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_SymbianNoSystemRotation", (long) Qt::WA_SymbianNoSystemRotation))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_MacNoShadow", (long) Qt::WA_MacNoShadow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX],
        &Sbk_Qt_Type, "WA_AttributeCount", (long) Qt::WA_AttributeCount))
        return ;
    // End of 'WidgetAttribute' enum.

    // Initialization of enum 'TouchPointState'.
    SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TouchPointState",
        "PySide.QtCore.Qt.TouchPointState",
        "Qt::TouchPointState");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointPressed", (long) Qt::TouchPointPressed))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointMoved", (long) Qt::TouchPointMoved))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointStationary", (long) Qt::TouchPointStationary))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointReleased", (long) Qt::TouchPointReleased))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointStateMask", (long) Qt::TouchPointStateMask))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX],
        &Sbk_Qt_Type, "TouchPointPrimary", (long) Qt::TouchPointPrimary))
        return ;
    // End of 'TouchPointState' enum.

    // Initialization of enum 'TextInteractionFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TEXTINTERACTIONFLAG__IDX] = &SbkPySide_QtCore_Qt_TextInteractionFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TextInteractionFlag",
        "PySide.QtCore.Qt.TextInteractionFlag",
        "Qt::TextInteractionFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TEXTINTERACTIONFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "NoTextInteraction", (long) Qt::NoTextInteraction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "TextSelectableByMouse", (long) Qt::TextSelectableByMouse))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "TextSelectableByKeyboard", (long) Qt::TextSelectableByKeyboard))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "LinksAccessibleByMouse", (long) Qt::LinksAccessibleByMouse))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "LinksAccessibleByKeyboard", (long) Qt::LinksAccessibleByKeyboard))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "TextEditable", (long) Qt::TextEditable))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "TextEditorInteraction", (long) Qt::TextEditorInteraction))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX],
        &Sbk_Qt_Type, "TextBrowserInteraction", (long) Qt::TextBrowserInteraction))
        return ;
    // End of 'TextInteractionFlag' enum.

    // Initialization of enum 'MouseButton'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MOUSEBUTTON__IDX] = &SbkPySide_QtCore_Qt_MouseButtons_Type;
    SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "MouseButton",
        "PySide.QtCore.Qt.MouseButton",
        "Qt::MouseButton",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MOUSEBUTTON__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "NoButton", (long) Qt::NoButton))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "LeftButton", (long) Qt::LeftButton))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "RightButton", (long) Qt::RightButton))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "MidButton", (long) Qt::MidButton))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "MiddleButton", (long) Qt::MiddleButton))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "XButton1", (long) Qt::XButton1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "XButton2", (long) Qt::XButton2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX],
        &Sbk_Qt_Type, "MouseButtonMask", (long) Qt::MouseButtonMask))
        return ;
    // End of 'MouseButton' enum.

    // Initialization of enum 'MatchFlag'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MATCHFLAG__IDX] = &SbkPySide_QtCore_Qt_MatchFlags_Type;
    SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "MatchFlag",
        "PySide.QtCore.Qt.MatchFlag",
        "Qt::MatchFlag",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MATCHFLAG__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchExactly", (long) Qt::MatchExactly))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchContains", (long) Qt::MatchContains))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchStartsWith", (long) Qt::MatchStartsWith))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchEndsWith", (long) Qt::MatchEndsWith))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchRegExp", (long) Qt::MatchRegExp))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchWildcard", (long) Qt::MatchWildcard))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchFixedString", (long) Qt::MatchFixedString))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchCaseSensitive", (long) Qt::MatchCaseSensitive))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchWrap", (long) Qt::MatchWrap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX],
        &Sbk_Qt_Type, "MatchRecursive", (long) Qt::MatchRecursive))
        return ;
    // End of 'MatchFlag' enum.

    // Initialization of enum 'PenCapStyle'.
    SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "PenCapStyle",
        "PySide.QtCore.Qt.PenCapStyle",
        "Qt::PenCapStyle");
    if (!SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX],
        &Sbk_Qt_Type, "FlatCap", (long) Qt::FlatCap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX],
        &Sbk_Qt_Type, "SquareCap", (long) Qt::SquareCap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX],
        &Sbk_Qt_Type, "RoundCap", (long) Qt::RoundCap))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX],
        &Sbk_Qt_Type, "MPenCapStyle", (long) Qt::MPenCapStyle))
        return ;
    // End of 'PenCapStyle' enum.

    // Initialization of enum 'TextElideMode'.
    SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_Qt_Type,
        "TextElideMode",
        "PySide.QtCore.Qt.TextElideMode",
        "Qt::TextElideMode");
    if (!SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX],
        &Sbk_Qt_Type, "ElideLeft", (long) Qt::ElideLeft))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX],
        &Sbk_Qt_Type, "ElideRight", (long) Qt::ElideRight))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX],
        &Sbk_Qt_Type, "ElideMiddle", (long) Qt::ElideMiddle))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX],
        &Sbk_Qt_Type, "ElideNone", (long) Qt::ElideNone))
        return ;
    // End of 'TextElideMode' enum.


    qRegisterMetaType< ::Qt::ShortcutContext >("Qt::ShortcutContext");
    qRegisterMetaType< ::Qt::CheckState >("Qt::CheckState");
    qRegisterMetaType< ::Qt::FocusPolicy >("Qt::FocusPolicy");
    qRegisterMetaType< ::Qt::GestureType >("Qt::GestureType");
    qRegisterMetaType< ::Qt::DropAction >("Qt::DropAction");
    qRegisterMetaType< ::Qt::DropActions >("Qt::DropActions");
    qRegisterMetaType< ::Qt::WindowType >("Qt::WindowType");
    qRegisterMetaType< ::Qt::WindowFlags >("Qt::WindowFlags");
    qRegisterMetaType< ::Qt::DateFormat >("Qt::DateFormat");
    qRegisterMetaType< ::Qt::TextFormat >("Qt::TextFormat");
    qRegisterMetaType< ::Qt::PenJoinStyle >("Qt::PenJoinStyle");
    qRegisterMetaType< ::Qt::GestureFlag >("Qt::GestureFlag");
    qRegisterMetaType< ::Qt::GestureFlags >("Qt::GestureFlags");
    qRegisterMetaType< ::Qt::CaseSensitivity >("Qt::CaseSensitivity");
    qRegisterMetaType< ::Qt::EventPriority >("Qt::EventPriority");
    qRegisterMetaType< ::Qt::ImageConversionFlag >("Qt::ImageConversionFlag");
    qRegisterMetaType< ::Qt::ImageConversionFlags >("Qt::ImageConversionFlags");
    qRegisterMetaType< ::Qt::CursorMoveStyle >("Qt::CursorMoveStyle");
    qRegisterMetaType< ::Qt::GestureState >("Qt::GestureState");
    qRegisterMetaType< ::Qt::BGMode >("Qt::BGMode");
    qRegisterMetaType< ::Qt::ConnectionType >("Qt::ConnectionType");
    qRegisterMetaType< ::Qt::ToolBarArea >("Qt::ToolBarArea");
    qRegisterMetaType< ::Qt::ToolBarAreas >("Qt::ToolBarAreas");
    qRegisterMetaType< ::Qt::CoordinateSystem >("Qt::CoordinateSystem");
    qRegisterMetaType< ::Qt::SizeMode >("Qt::SizeMode");
    qRegisterMetaType< ::Qt::FocusReason >("Qt::FocusReason");
    qRegisterMetaType< ::Qt::Modifier >("Qt::Modifier");
    qRegisterMetaType< ::Qt::TileRule >("Qt::TileRule");
    qRegisterMetaType< ::Qt::WhiteSpaceMode >("Qt::WhiteSpaceMode");
    qRegisterMetaType< ::Qt::AspectRatioMode >("Qt::AspectRatioMode");
    qRegisterMetaType< ::Qt::SizeHint >("Qt::SizeHint");
    qRegisterMetaType< ::Qt::AlignmentFlag >("Qt::AlignmentFlag");
    qRegisterMetaType< ::Qt::Alignment >("Qt::Alignment");
    qRegisterMetaType< ::Qt::ContextMenuPolicy >("Qt::ContextMenuPolicy");
    qRegisterMetaType< ::Qt::DockWidgetArea >("Qt::DockWidgetArea");
    qRegisterMetaType< ::Qt::DockWidgetAreas >("Qt::DockWidgetAreas");
    qRegisterMetaType< ::Qt::UIEffect >("Qt::UIEffect");
    qRegisterMetaType< ::Qt::AnchorPoint >("Qt::AnchorPoint");
    qRegisterMetaType< ::Qt::GlobalColor >("Qt::GlobalColor");
    qRegisterMetaType< ::Qt::KeyboardModifier >("Qt::KeyboardModifier");
    qRegisterMetaType< ::Qt::KeyboardModifiers >("Qt::KeyboardModifiers");
    qRegisterMetaType< ::Qt::NavigationMode >("Qt::NavigationMode");
    qRegisterMetaType< ::Qt::ItemDataRole >("Qt::ItemDataRole");
    qRegisterMetaType< ::Qt::ScrollBarPolicy >("Qt::ScrollBarPolicy");
    qRegisterMetaType< ::Qt::InputMethodHint >("Qt::InputMethodHint");
    qRegisterMetaType< ::Qt::InputMethodHints >("Qt::InputMethodHints");
    qRegisterMetaType< ::Qt::AnchorAttribute >("Qt::AnchorAttribute");
    qRegisterMetaType< ::Qt::WindowModality >("Qt::WindowModality");
    qRegisterMetaType< ::Qt::SortOrder >("Qt::SortOrder");
    qRegisterMetaType< ::Qt::PenStyle >("Qt::PenStyle");
    qRegisterMetaType< ::Qt::ItemFlag >("Qt::ItemFlag");
    qRegisterMetaType< ::Qt::ItemFlags >("Qt::ItemFlags");
    qRegisterMetaType< ::Qt::Axis >("Qt::Axis");
    qRegisterMetaType< ::Qt::TransformationMode >("Qt::TransformationMode");
    qRegisterMetaType< ::Qt::WindowFrameSection >("Qt::WindowFrameSection");
    qRegisterMetaType< ::Qt::HitTestAccuracy >("Qt::HitTestAccuracy");
    qRegisterMetaType< ::Qt::CursorShape >("Qt::CursorShape");
    qRegisterMetaType< ::Qt::ItemSelectionMode >("Qt::ItemSelectionMode");
    qRegisterMetaType< ::Qt::Orientation >("Qt::Orientation");
    qRegisterMetaType< ::Qt::Orientations >("Qt::Orientations");
    qRegisterMetaType< ::Qt::InputMethodQuery >("Qt::InputMethodQuery");
    qRegisterMetaType< ::Qt::TimeSpec >("Qt::TimeSpec");
    qRegisterMetaType< ::Qt::ArrowType >("Qt::ArrowType");
    qRegisterMetaType< ::Qt::FillRule >("Qt::FillRule");
    qRegisterMetaType< ::Qt::MaskMode >("Qt::MaskMode");
    qRegisterMetaType< ::Qt::WindowState >("Qt::WindowState");
    qRegisterMetaType< ::Qt::WindowStates >("Qt::WindowStates");
    qRegisterMetaType< ::Qt::ToolBarAreaSizes >("Qt::ToolBarAreaSizes");
    qRegisterMetaType< ::Qt::Corner >("Qt::Corner");
    qRegisterMetaType< ::Qt::DayOfWeek >("Qt::DayOfWeek");
    qRegisterMetaType< ::Qt::ClipOperation >("Qt::ClipOperation");
    qRegisterMetaType< ::Qt::LayoutDirection >("Qt::LayoutDirection");
    qRegisterMetaType< ::Qt::ToolButtonStyle >("Qt::ToolButtonStyle");
    qRegisterMetaType< ::Qt::DockWidgetAreaSizes >("Qt::DockWidgetAreaSizes");
    qRegisterMetaType< ::Qt::Key >("Qt::Key");
    qRegisterMetaType< ::Qt::ApplicationAttribute >("Qt::ApplicationAttribute");
    qRegisterMetaType< ::Qt::TextFlag >("Qt::TextFlag");
    qRegisterMetaType< ::Qt::BrushStyle >("Qt::BrushStyle");
    qRegisterMetaType< ::Qt::WidgetAttribute >("Qt::WidgetAttribute");
    qRegisterMetaType< ::Qt::TouchPointState >("Qt::TouchPointState");
    qRegisterMetaType< ::Qt::TextInteractionFlag >("Qt::TextInteractionFlag");
    qRegisterMetaType< ::Qt::TextInteractionFlags >("Qt::TextInteractionFlags");
    qRegisterMetaType< ::Qt::MouseButton >("Qt::MouseButton");
    qRegisterMetaType< ::Qt::MouseButtons >("Qt::MouseButtons");
    qRegisterMetaType< ::Qt::MatchFlag >("Qt::MatchFlag");
    qRegisterMetaType< ::Qt::MatchFlags >("Qt::MatchFlags");
    qRegisterMetaType< ::Qt::PenCapStyle >("Qt::PenCapStyle");
    qRegisterMetaType< ::Qt::TextElideMode >("Qt::TextElideMode");
}
